Titanium.include( '/functions/images.js' );
Titanium.include( '/functions/css.js' );
Titanium.include( '/classes/topbar.class.js' );

/* Variables */

// Ventana actual
var vCurrent = Titanium.UI.currentWindow;
// Tabla de opciones
var tTable = undefined;

/* TopBar */

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

/* Mi cuenta */

// Función para mostrar las opciones de mi cuenta
Titanium.App.addEventListener( 'myAccount', function()
{
	/* Cálculo de tamaños */

	var nWidth = Titanium.Platform.displayCaps.platformWidth;
	var nHeight = Titanium.Platform.displayCaps.platformHeight;

	// Calculamos el ancho y alto según la densidad
	if( Titanium.Platform.osname == 'android' )
	{
		// Ancho y alto según densidad
		nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
		nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	}

	var nLogoSize = wPer( 205 ) + 10;
	var nRowSize = (nHeight - (Titanium.App.topBarSize + Titanium.App.tabGroupSize + nLogoSize + 10 + 12) - 10) / 4;
	var nImageSize = nWidth * 0.08437;

	// Mostramos el logo
	var aLogo = Titanium.UI.createImageView({ image:getImage( 'title.png' ), top:Titanium.App.top, width:wPer( 320 ), height:wPer( 205 ) });
	Titanium.UI.currentWindow.add( aLogo );

	// Mi cuenta //

	// Opciones si el usuario está logueado
	if( Titanium.App.User.isLogged() )
		aMenu = [
			{ title:getLocatedString( 'window_logout' ), image:'account_login_off.png', description:getLocatedString( 'message_window_logout' ), window:'account_logout.js' },
			{ title:getLocatedString( 'window_my_info' ), image:'account_info_off.png', description:getLocatedString( 'message_window_my_info' ), window:'account_info.js' },
			{ title:getLocatedString( 'window_history' ), image:'account_history_off.png', description:getLocatedString( 'message_window_history' ), window:'account_history.js' },
			{ title:getLocatedString( 'window_preferences' ), image:'account_preferences_off.png', description:getLocatedString( 'message_window_preferences' ), window:'account_preferences.js' }];
	// Opciones si el usuario no está logueado
	else
		aMenu = [
			{ title:getLocatedString( 'window_login' ), image:'account_login_off.png', description:getLocatedString( 'message_window_login' ), window:'account_login.js' },
			{ title:getLocatedString( 'window_register' ), image:'account_register_off.png', description:getLocatedString( 'message_window_register' ), window:'account_register' + (Titanium.App.register_distributor == true ? '_selection' : '') + '.js' },
			{ title:getLocatedString( 'window_history' ), image:'account_history_off.png', description:getLocatedString( 'message_window_history' ), window:'account_history.js' },
			{ title:getLocatedString( 'window_preferences' ), image:'account_preferences_off.png', description:getLocatedString( 'message_window_preferences' ), window:'account_preferences.js' }];

	// Si ya existiera la tabla la vaciamos
	if( tTable != undefined )
		Titanium.UI.currentWindow.remove( tTable );

	// Creamos la tabla para mostrar las categorías principales
	tTable = Titanium.UI.createTableView({ left:17, right:17, top:aLogo.top + aLogo.height + 10, bottom:Titanium.App.bottom + 10, separatorStyle:0, backgroundColor:'transparent' });

	// Array de datos
	var aData = [];

	// Recorremos el resultado y lo añadimos a la tabla
	for( var nCont = 0; nCont < aMenu.length; nCont++ )
	{
		// Creamos la fila
		var aRow = Titanium.UI.createTableViewRow({ text:aMenu[nCont].title, height:nRowSize, className:'account', backgroundColor:'transparent', selectedBackgroundColor:'transparent', hasChild:false, window:aMenu[nCont].window });

		// Bordes de la fila
		var iBorder = Titanium.UI.createView({ backgroundColor:'#000000', borderColor:'#ddc559', borderWidth:1, borderRadius:4 });
		aRow.add( iBorder );
		aRow.row_border = iBorder;
		// Creamos la imagen izquierda
		var iImage =  Titanium.UI.createImageView({ image:getImage( aMenu[nCont].image ), width:nImageSize, height:nImageSize, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
		aRow.add( iImage );
		aRow.row_image = iImage;
		// Creamos el label del titulo
		var lTitle = Titanium.UI.createLabel({ text:aMenu[nCont].title, font:{ fontName:'Helvetica Neue', fontSize:wPer( 28 ), fontWeight:'bold' }, color:'#ddc559', top:nRowSize / 6, left:(iImage.left * 2) + iImage.width, height:nRowSize / 3.4 });
		aRow.add( lTitle );
		aRow.row_title = lTitle;
		// Creamos el label de descripción
		var lDescription = Titanium.UI.createLabel({ text:aMenu[nCont].description, font:{ fontName:'Helvetica Neue', fontSize:wPer( 20 ), fontWeight:'regular' }, color:'#ddc559', bottom:lTitle.top - (lTitle.top / 4), left:(iImage.left * 2) + iImage.width, right:lTitle.left });
		aRow.add( lDescription );
		aRow.row_description = lDescription;
		// Creamos la flecha derecha
		var iArrow = Titanium.UI.createImageView({ image:getImage( 'row_arrow_off.png' ), right:wPer( 30 ), width:wPer( 16 ), height:wPer( 25 ) });
		aRow.add( iArrow );
		aRow.row_arrow = iArrow;

		// Creamos la fila de espacio
		var aRowSpace = Titanium.UI.createTableViewRow({ id:'none', className:'sections_none', backgroundColor:'transparent', hasChild:false });
		css( aRowSpace, 'catalog_table_row_space' );

		// Añadimos la fila a los datos
		aData.push( aRow );
		aData.push( aRowSpace );
	}

	// Añadimos los datos a la tabla
	tTable.setData( aData );

	// Añadimos la tabla
	vCurrent.add( tTable );

	// Evento cuando pulsamos en un elemento de la lista
	tTable.addEventListener('touchstart', function(e)
	{
		// Cambiamos los colores
		if( e.rowData.row_border != undefined )
		{
			e.rowData.row_image.image = e.rowData.row_image.image.replace( 'off', 'on' );
			e.rowData.row_border.backgroundColor = '#ddc559';
			e.rowData.row_title.color = '#000000';
			e.rowData.row_description.color = '#000000';
			e.rowData.row_arrow.image = getImage( 'row_arrow_on.png' );
		}
	});

	// Evento cuando soltamos un elemento de la lista
	tTable.addEventListener('touchend', function(e)
	{
		// Cambiamos los colores
		if( e.rowData.row_border != undefined )
		{
			e.rowData.row_image.image = e.rowData.row_image.image.replace( 'on', 'off' );
			e.rowData.row_border.backgroundColor = '#000000';
			e.rowData.row_title.color = '#ddc559';
			e.rowData.row_description.color = '#ddc559';
			e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
		}
	});

	// Evento cuando soltamos un elemento de la lista
	tTable.addEventListener('touchcancel', function(e)
	{
		// Cambiamos los colores
		if( e.rowData.row_border != undefined )
		{
			e.rowData.row_image.image = e.rowData.row_image.image.replace( 'on', 'off' );
			e.rowData.row_border.backgroundColor = '#000000';
			e.rowData.row_title.color = '#ddc559';
			e.rowData.row_description.color = '#ddc559';
			e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
		}
	});

	// Evento cuando hacemos click en un elemento de la lista
	tTable.addEventListener('click', function(e)
	{
		if( e.rowData.window != '' && e.rowData.window != undefined )
		{
			// Abrimos la ventana de categorias
			var wWindow = Titanium.UI.createWindow({ title:e.rowData.text, backgroundImage:getImage( 'background.png' ), backgroundColor:'#383b3d', url:e.rowData.window, windowParent:Titanium.UI.currentWindow });
	
			// Abrimos la ventana
			openWindowInTab( wWindow );
		}
	});
});

// Mostramos las opciones
Titanium.App.fireEvent( 'myAccount', {} );