Titanium.include( 'database.js' );
Titanium.include( '/functions/currencies.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );
Titanium.include( '/classes/user.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

/* Obtenemos la cuenta de usuario */

var aUser = Titanium.App.User;

/* Cálculo de tamaños */

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Calculamos el ancho y alto según la densidad
if( Titanium.Platform.osname == 'android' )
{
	// Ancho y alto según densidad
	nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
}

/* Bloque de información */

// Creamos la vista para el bloque
var vInformation = Titanium.UI.createView({ left:nWidth * 0.05312, right:nWidth * 0.05312, top:Titanium.App.top + (nWidth * 0.05312), height:nHeight * 0.1708, backgroundImage:getImage( 'account_title.png' ), borderRadius:4 });
// Creamos la imágen izquierda
var iImage =  Titanium.UI.createImageView({ image:getImage( 'account_history_on.png' ), width:nWidth * 0.08437, height:nWidth * 0.08437, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
vInformation.add( iImage );
// Creamos el label del titulo
var lTitle = Titanium.UI.createLabel({ text:getLocatedString( 'window_history' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.05625, fontWeight:'bold' }, color:'#000000', top:iImage.left, left:(iImage.left * 2) + iImage.width, height:vInformation.height / 4 });
vInformation.add( lTitle );
// Creamos el label de descripción
var lDescription = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_history' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.03615, fontWeight:'regular' }, color:'#000000', top:lTitle.top + lTitle.height, left:(iImage.left * 2) + iImage.width, right:(iImage.left * 2) + iImage.width, height:(vInformation.height / 3) * 2 });
vInformation.add( lDescription );
Titanium.UI.currentWindow.add( vInformation );

/* Historial */

// Si el usuario está logueado
if( aUser.isLogged() )
{
	// Hacemos una consulta para obtener los pedidos del usuario
	query({ query:'getOrdersByCustomer', data:{ userid:aUser.getUserid(), language:Titanium.App.idlanguage }, callback:function(aResult)
		{
			// Si obtenemos un resultado correcto
			if( aResult !== false )
			{
				// Si hemos obtenido pedidos
				if( aResult.length > 0 )
				{
					/* Cálculo de tamaños */

					var nRowSize = (nHeight - (Titanium.App.topBarSize + Titanium.App.tabGroupSize + vInformation.height + (vInformation.left * 2))) / 2.7;

					/* Historial */

					// Creamos la tabla para mostrar las categorías principales
					var tTable = Titanium.UI.createTableView({ left:0, right:0, top:vInformation.top + vInformation.height + vInformation.left, bottom:Titanium.App.bottom });

					// Array de datos
					var aData = [];

					// Recorremos el resultado y lo añadimos a la tabla
					for( var nCont = 0; nCont < aResult.length; nCont++ )
					{
						// Creamos la fila
						var aRow = Titanium.UI.createTableViewRow({ id:aResult[nCont].idorder, height:nRowSize, className:'orders', backgroundColor:(nCont % 2 == 0 ? '#eeeeee' : '#ffffff'), selectedBackgroundColor:'#f7b06b', hasChild:false });

						// Creamos el label del número de pedido
						var lOrder = Titanium.UI.createWebView({ html:'<font face="Helvetica Neue" color="#312f2f"><b>' + getLocatedString( 'text_order' ) + ':</b></font> <font face="Helvetica Neue" color="#979696"><b>' + aResult[nCont].idorder + '</b></font><br /><font face="Helvetica Neue" color="#312f2f"><b>' + getLocatedString( 'text_date' ) + ':</b></font> <font face="Helvetica Neue" color="#979696">' + aResult[nCont].date + '</font><br /><font face="Helvetica Neue" color="#312f2f"><b>' + getLocatedString( 'text_status' ) + ':</b></font> <font face="Helvetica Neue" color="#979696">' + aResult[nCont].status + '</font>', width:nWidth / 2, height:nRowSize, left:0, top:0, backgroundColor:'transparent', enableZoomControls:false, loading:false });
						aRow.add( lOrder );
						// Creamos el botón de ver pedido
						var bView = Titanium.UI.createButton({ title:getLocatedString( 'text_view' ), right:nWidth * 0.05312, top:nRowSize / 2, width:nWidth * 0.2718, height:nHeight * 0.05208, backgroundImage:getImage( 'button_account_enter.png' ) });
						aRow.add( bView );

						// Añadimos la fila a los datos
						aData.push( aRow );
					}

					// Añadimos los datos a la tabla
					tTable.setData( aData );

					// Añadimos la tabla
					Titanium.UI.currentWindow.add( tTable );

					// Evento cuando hacemos click en un elemento de la lista
					tTable.addEventListener('click', function(e)
					{
						// Abrimos la ventana de detalle de pedido
						var wOrderDetail = Titanium.UI.createWindow({ id:e.rowData.id, title:getLocatedString( 'text_order' ) + ' ' + e.rowData.id, backgroundImage:getImage( 'background.png' ), url:'account_history_detail.js', windowParent:Titanium.UI.currentWindow });

						// Abrimos la ventana
						openWindowInTab( wOrderDetail );
					});
				}
				// Si no hemos obtenido pedidos
				else
				{
					// Label informativo
					var lInformation = Titanium.UI.createLabel({ text:getLocatedString( 'message_no_history' ), color:Titanium.App.general_font_color, top:vInformation.top + vInformation.height + vInformation.left, left:nWidth * 0.03125, right:nWidth * 0.03125, height:nHeight * 0.25 });
					Titanium.UI.currentWindow.add( lInformation );
				}
			}
		}
	});
}
// Si el usuario no está logueado
else
{
	// Label informativo
	var lInformation = Titanium.UI.createLabel({ text:getLocatedString( 'message_history' ), color:'#FFFFFF', top:vInformation.top + vInformation.height + vInformation.left, left:nWidth * 0.03125, right:nWidth * 0.03125, height:nHeight * 0.25 });
	Titanium.UI.currentWindow.add( lInformation );

	// Botón para login
	var bLogin = Titanium.UI.createButton({ title:getLocatedString( 'text_login' ), top:lInformation.top + lInformation.height + vInformation.left, width:nWidth * 0.7156, height:nHeight * 0.075, backgroundImage:getImage( 'button_account_enter.png' ) });
	Titanium.UI.currentWindow.add( bLogin );

	// Evento cuando hacemos click en Login
	bLogin.addEventListener( 'click', function(e)
	{
		// Abrimos la ventana de login
		var wWindow = Titanium.UI.createWindow({ title:getLocatedString( 'window_login' ), backgroundImage:getImage( 'background.png' ), url:'account_login.js', windowParent:Titanium.UI.currentWindow });

		// Abrimos la ventana
		openWindowInTab( wWindow );

		// Evento cuando se cierra la ventana
		wWindow.addEventListener( 'close', function(e)
		{
			// Si el usuario está logueado cerramos la ventana actual también
			if( Titanium.App.User.isLogged() )
				Titanium.UI.currentWindow.close();
		});
	});

	// Botón para registrarse
	var bRegister = Titanium.UI.createButton({ title:getLocatedString( 'text_create_new_account' ), color:'#ffffff', top:bLogin.top + bLogin.height + vInformation.left, width:nWidth * 0.7156, height:nHeight * 0.075, backgroundImage:getImage( 'button_account_register.png' ) });
	Titanium.UI.currentWindow.add( bRegister );

	// Evento cuando hacemos click en Registro
	bRegister.addEventListener( 'click', function(e)
	{
		// Abrimos la ventana de registro
		var wWindow = Titanium.UI.createWindow({ title:getLocatedString( 'window_register' ), backgroundImage:getImage( 'background.png' ), url:'account_register.js', windowParent:Titanium.UI.currentWindow });

		// Abrimos la ventana
		openWindowInTab( wWindow );

		// Evento cuando se cierra la ventana
		wWindow.addEventListener( 'close', function(e)
		{
			// Si el usuario está logueado cerramos la ventana actual también
			if( Titanium.App.User.isLogged() )
				Titanium.UI.currentWindow.close();
		});
	});
}