Titanium.include( 'database.js' );
Titanium.include( '/functions/currencies.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

/* Obtenemos la cuenta de usuario */

var aUser = Titanium.App.User;

/* Pedido */

// Hacemos una consulta para obtener el pedido
query({ query:'getOrderByOrderAndCustomer', data:{ idorder:Titanium.UI.currentWindow.id, userid:aUser.getUserid(), language:Titanium.App.idlanguage }, callback:function(aResult)
	{
		// Si obtenemos un resultado correcto
		if( aResult !== false )
		{
			/* Pedido */

			// Recreamos el código HTML
			var sHtml = '<body style="margin:0px 0px 10px 0px;"> \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;background-color:#e8e8e8;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order' ) + ' <font color="#d55023" size="6">' + aResult.idorder + '</font> <font color="#979696">(' + aResult.status + ')</font></h4> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_total' ) + '</h4> \
		<ul> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.total + '</b></li> \
		</ul> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_date' ) + '</h4> \
		<ul> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.date + '</b></li> \
		</ul> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_address' ) + '</h4> \
		<ul> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.delivery_company + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.delivery_name + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.delivery_street_address + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.delivery_city + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.delivery_postcode + ' - ' + aResult.delivery_state + ', ' + aResult.delivery_country + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>N.I.F. ' + aResult.nif + '</b></li> \
		</ul> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_shipping_costs' ) + '</h4> \
		<ul> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.shipping + '</b></li> \
		</ul> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_products' ) + '</h4> \
 \
		<table cellspacing="0" cellpadding="2" border="0" width="100%"> \
			<tbody>';
			for( var nCont = 0; nCont < aResult.products.length; nCont++ )
			{
sHtml += '		<tr> \
					<td align="right" width="30" valign="top" style="color:#979696;"><b>' + aResult.products[nCont].quantity + '&nbsp;x</b></td> \
					<td valign="top" style="color:#979696;"><b>' + aResult.products[nCont].name + '</b></td> \
					<td align="right" valign="top" style="color:#979696;"><b>' + getPriceFormatted( aResult.products[nCont].price, aResult.products[nCont].tax ) + '€</b></td> \
				</tr>';
			}
sHtml += '	</tbody> \
		</table> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_billing_address' ) + '</h4> \
		<ul> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.billing_company + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.billing_name + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.billing_street_address + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.billing_city + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.billing_postcode + ' - ' + aResult.billing_state + ', ' + aResult.billing_country + '</b></li> \
			<li style="list-style-type:none;color:#979696;"><b>N.I.F. ' + aResult.nif + '</b></li> \
		</ul> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_payment' ) + '</h4> \
		<ul> \
			<li style="list-style-type:none;color:#979696;"><b>' + aResult.payment_method + '</b></li> \
		</ul> \
 \
		<table cellspacing="0" cellpadding="2" border="0" width="100%"> \
			<tbody>';
			for( var nCont = 0; nCont < aResult.totals.length; nCont++ )
			{
sHtml += '		<tr> \
					<td align="right" width="100%" style="color:#979696;"><b>' + aResult.totals[nCont].title + '</b></td> \
					<td align="right" style="color:#979696;">' + aResult.totals[nCont].text + '</td> \
				</tr>';
			}
sHtml += '	</tbody> \
		</table> \
	</div> \
 \
	<div style="font-family:Helvetica Neue;color:#312f2f;border-bottom:1px solid #d9d9d9;"> \
		<h4 style="padding-left:10px;">' + getLocatedString( 'text_order_status' ) + '</h4> \
		<ul>';
			for( var nCont = 0; nCont < aResult.status_history.length; nCont++ )
sHtml += '	<li style="list-style-type:none;color:#979696;"><b>' + aResult.status_history[nCont].date + ' ' + aResult.status_history[nCont].status + '</b></li>';
sHtml += '</ul> \
	</div> \
</body>';

			// Creamos el visor web para mostrar el pedido
			var wOrder = Titanium.UI.createWebView({ html:sHtml, left:0, right:0, top:Titanium.App.top, bottom:Titanium.App.bottom, backgroundColor:'#ffffff', enableZoomControls:false, loading:false });

			// Añadimos el visor web
			Titanium.UI.currentWindow.add( wOrder );
		}
	}
});