Titanium.include( 'database.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/forms.class.js' );
Titanium.include( '/classes/topbar.class.js' );
Titanium.include( '/classes/user.class.js' );

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

// Obtenemos la cuenta de usuario
var aUser = Titanium.App.User;

// Cálculo de tamaños //

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Calculamos el ancho y alto según la densidad
if( Titanium.Platform.osname == 'android' )
{
	// Ancho y alto según densidad
	nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
}

// Bloque de información //

// Creamos el contenedor scroll
var sContent = Titanium.UI.createScrollView({ left:0, right:0, top:Titanium.App.top, bottom:Titanium.App.bottom, backgroundColor:'transparent', contentWidth:'auto', contentHeight:'auto', layout:'vertical', showVerticalScrollIndicator:true });
Titanium.UI.currentWindow.add( sContent );

// Creamos la vista para el bloque
var vInformation = Titanium.UI.createView({ left:nWidth * 0.05312, right:nWidth * 0.05312, top:nWidth * 0.05312, height:nHeight * 0.1708, backgroundImage:getImage( 'account_title.png' ), borderRadius:4 });
// Creamos la imágen izquierda
var iImage =  Titanium.UI.createImageView({ image:getImage( 'account_info_on.png' ), width:nWidth * 0.08437, height:nWidth * 0.08437, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
vInformation.add( iImage );
// Creamos el label del titulo
var lTitle = Titanium.UI.createLabel({ text:getLocatedString( 'window_my_info' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.05625, fontWeight:'bold' }, color:'#000000', top:iImage.left, left:(iImage.left * 2) + iImage.width, height:vInformation.height / 4 });
vInformation.add( lTitle );
// Creamos el label de descripción
var lDescription = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_my_info' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.03615, fontWeight:'regular' }, color:'#000000', top:lTitle.top + lTitle.height, left:(iImage.left * 2) + iImage.width, right:(iImage.left * 2) + iImage.width, height:(vInformation.height / 3) * 2 });
vInformation.add( lDescription );
sContent.add( vInformation );

// Información //

// Hacemos una consulta para obtener la información del usuario
query({ query:'getCustomerByID', data:{ userid:aUser.getUserid() }, callback:function(aResult)
{
	// Nos posicionamos en el registro
	aResult = aResult[0];
	
	// Clase para el formulario
	var aForm = new form( sContent );

	// Creamos todos los campos
	aForm.addField({ name:getLocatedString( 'text_name' ), hintText:aResult.name, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_surname' ), hintText:aResult.lastname, enabled:false });
	//aForm.addField({ name:getLocatedString( 'text_dni' ), hintText:aResult.dni, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_email' ), hintText:aResult.email, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_address' ), hintText:aResult.address, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_cp' ), hintText:aResult.cp, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_country' ), hintText:aResult.country, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_state' ), hintText:aResult.state, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_city' ), hintText:aResult.city, enabled:false });
	aForm.addField({ name:getLocatedString( 'text_telephone' ), hintText:aResult.telephone, enabled:false });

	// Vista para añadir espacio en blanco
	var vSpace = Titanium.UI.createView({ top:0, height:vInformation.left, backgroundColor:'transparent' });
	sContent.add( vSpace );
}});