Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );
Titanium.include( '/classes/user.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

/* Obtenemos la cuenta de usuario */

var aUser = Titanium.App.User;

/* Cálculo de tamaños */

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Calculamos el ancho y alto según la densidad
if( Titanium.Platform.osname == 'android' )
{
	// Ancho y alto según densidad
	nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
}

/* Bloque de información */

// Creamos la vista para el bloque
var vInformation = Titanium.UI.createView({ left:nWidth * 0.05312, right:nWidth * 0.05312, top:Titanium.App.top + (nWidth * 0.05312), height:nHeight * 0.1708, backgroundImage:getImage( 'account_title.png' ), borderRadius:4 });
// Creamos la imágen izquierda
var iImage =  Titanium.UI.createImageView({ image:getImage( 'account_login_on.png' ), width:nWidth * 0.08437, height:nWidth * 0.08437, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
vInformation.add( iImage );
// Creamos el label del titulo
var lTitle = Titanium.UI.createLabel({ text:getLocatedString( 'window_logout' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.05625, fontWeight:'bold' }, color:'#000000', top:iImage.left, left:(iImage.left * 2) + iImage.width, height:vInformation.height / 4 });
vInformation.add( lTitle );
// Creamos el label de descripción
var lDescription = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_logout' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.03615, fontWeight:'regular' }, color:'#000000', top:lTitle.top + lTitle.height, left:(iImage.left * 2) + iImage.width, right:(iImage.left * 2) + iImage.width, height:(vInformation.height / 3) * 2 });
vInformation.add( lDescription );
Titanium.UI.currentWindow.add( vInformation );

/* Logout */

// Botón para salir
var bLogout = Titanium.UI.createButton({ title:getLocatedString( 'text_logout' ), top:vInformation.top + vInformation.height + vInformation.left, width:nWidth * 0.7156, height:nHeight * 0.075, backgroundImage:getImage( 'button_account_enter.png' ) });
Titanium.UI.currentWindow.add( bLogout );

// Evento cuando hacemos click en Enviar
bLogout.addEventListener( 'click', function(e)
{
	// Obtenemos el nombre de usuario
	var sUser = aUser.getUsername();

	// Establecemos los datos
	aUser.setUserid( false );
	aUser.setEmail( false );
	aUser.setUsername( false );
	aUser.setPassword( false );

	// Marcamos al usuario como logueado
	aUser.setLogged( false );

	// Mostramos mensaje de despedida
	Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_message' ), message:getLocatedString( 'text_goodbye' ).replace( '%s', sUser ), buttonNames:[getLocatedString( 'text_accept' )] }).show();

	// Guardamos al usuario en la sesión
	Titanium.App.User = aUser;

	// Llamamos a la función para mostrar las opciones
	Titanium.App.fireEvent( 'myAccount', {} );

	// Cerramos la ventana
	Titanium.UI.currentWindow.close();
});