Titanium.include( 'database.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/forms.class.js' );
Titanium.include( '/classes/topbar.class.js' );
Titanium.include( '/classes/user.class.js' );

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

// Obtenemos la cuenta de usuario
var aUser = Titanium.App.User;

// Cálculo de tamaños //

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Calculamos el ancho y alto según la densidad
if( Titanium.Platform.osname == 'android' )
{
	// Ancho y alto según densidad
	nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
}

// Bloque de información //

// Creamos el contenedor scroll
var sContent = Titanium.UI.createScrollView({ left:0, right:0, top:Titanium.App.top, bottom:Titanium.App.bottom, backgroundColor:'transparent', contentWidth:'auto', contentHeight:'auto', layout:'vertical', showVerticalScrollIndicator:true });
Titanium.UI.currentWindow.add( sContent );

// Creamos la vista para el bloque
var vInformation = Titanium.UI.createView({ left:nWidth * 0.05312, right:nWidth * 0.05312, top:nWidth * 0.05312, height:nHeight * 0.1708, backgroundImage:getImage( 'account_title.png' ), borderRadius:4 });
// Creamos la imágen izquierda
var iImage =  Titanium.UI.createImageView({ image:getImage( 'account_preferences_on.png' ), width:nWidth * 0.08437, height:nWidth * 0.08437, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
vInformation.add( iImage );
// Creamos el label del titulo
var lTitle = Titanium.UI.createLabel({ text:getLocatedString( 'window_preferences' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.05625, fontWeight:'bold' }, color:'#000000', top:iImage.left, left:(iImage.left * 2) + iImage.width, height:vInformation.height / 4 });
vInformation.add( lTitle );
// Creamos el label de descripción
var lDescription = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_preferences' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.03615, fontWeight:'regular' }, color:'#000000', top:lTitle.top + lTitle.height, left:(iImage.left * 2) + iImage.width, right:(iImage.left * 2) + iImage.width, height:(vInformation.height / 3) * 2 });
vInformation.add( lDescription );
sContent.add( vInformation );

// Preferencias //

// Obtenemos el idioma seleccionado
var sLanguage = 'Español';
for( nCont = 0; nCont < Titanium.App.languages.length; nCont++ )
	if( Titanium.App.languages[nCont].id == Titanium.App.idlanguage )
		sLanguage = Titanium.App.languages[nCont].value;

// Clase para el formulario
var aForm = new form( sContent );

// Creamos todos los campos
var aLanguage = aForm.addCombo({ name:'Idioma / Language', hintText:sLanguage, values:Titanium.App.languages, defaultValue:Titanium.App.idlanguage }, {});
aForm.addCombo({ name:getLocatedString( 'text_version' ), hintText:Titanium.App.store_name + ' ' + Titanium.App.getVersion(), enabled:false }, {});

// Botón para aceptar
var bContinue = Titanium.UI.createButton({ title:getLocatedString( 'text_continue' ), top:15, width:nWidth * 0.7156, height:nHeight * 0.075, backgroundImage:getImage( 'button_account_enter.png' ) });
sContent.add( bContinue );

// Evento cuando hacemos click en continuar
bContinue.addEventListener( 'click', function(e)
{
	// Establecemos el idioma seleccionado
	Titanium.App.language = aLanguage.text.toLowerCase().substr( 0, 2 );
	Titanium.App.idlanguage = aLanguage.id;

	// Añadimos el idioma en la configuración
	var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, 'lang.txt' );
	aFile.write( Titanium.App.language + ':' + Titanium.App.idlanguage );

	// Mensaje de información
	Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_message' ), message:getLocatedString( 'message_language_change' ), buttonNames:['Aceptar'] }).show();
});