Titanium.include( 'database.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/forms.class.js' );
Titanium.include( '/classes/saves.class.js' );
Titanium.include( '/classes/topbar.class.js' );
Titanium.include( '/classes/user.class.js' );

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

// Obtenemos la cuenta de usuario
var aUser = Titanium.App.User;

// Cálculo de tamaños //

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Calculamos el ancho y alto según la densidad
if( Titanium.Platform.osname == 'android' )
{
	// Ancho y alto según densidad
	nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
}

// Valores por defecto
var sName = (Titanium.App.isSimulator ? 'Sergio' : '');
var sLastName = (Titanium.App.isSimulator ? 'Ruiz Sánchez' : '');
var sBirthday = (Titanium.App.isSimulator ? '14/12/1985' : '');
var sDNI = (Titanium.App.isSimulator ? '75778360F' : '');
var sEnterprise = (Titanium.App.isSimulator ? 'Denox' : '');
var sEquivalence = (Titanium.App.isSimulator ? 0 : '');
var sEmail = (Titanium.App.isSimulator ? 'sergio.ruiz@denox.es' : '');
var sAddress = (Titanium.App.isSimulator ? 'Plaza Becquer, 1, esc. 2, piso 10, 2-I' : '');
var sCP = (Titanium.App.isSimulator ? '11010' : '');
var sState = (Titanium.App.isSimulator ? 142 : '');
var sCity = (Titanium.App.isSimulator ? 'Cadiz' : '');
var sTelephone = (Titanium.App.isSimulator ? '626561341' : '');
var sPassword = (Titanium.App.isSimulator ? 'adm914A' : '');
var bDistributor = (Titanium.UI.currentWindow.distributor != undefined && Titanium.UI.currentWindow.distributor == true);

// Bloque de información //

// Creamos el contenedor scroll
var sContent = Titanium.UI.createScrollView({ left:0, right:0, top:Titanium.App.top, bottom:Titanium.App.bottom, backgroundColor:'transparent', contentWidth:'auto', contentHeight:'auto', layout:'vertical', showVerticalScrollIndicator:true });
Titanium.UI.currentWindow.add( sContent );

// Creamos la vista para el bloque
var vInformation = Titanium.UI.createView({ left:nWidth * 0.05312, right:nWidth * 0.05312, top:nWidth * 0.05312, height:nHeight * 0.1708, backgroundImage:getImage( 'account_title.png' ), borderRadius:4 });
// Creamos la imágen izquierda
var iImage =  Titanium.UI.createImageView({ image:getImage( 'account_register_on.png' ), width:nWidth * 0.08437, height:nWidth * 0.08437, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
vInformation.add( iImage );
// Creamos el label del titulo
var lTitle = Titanium.UI.createLabel({ text:getLocatedString( 'window_register' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.05625, fontWeight:'bold' }, color:'#000000', top:iImage.left, left:(iImage.left * 2) + iImage.width, height:vInformation.height / 4 });
vInformation.add( lTitle );
// Creamos el label de descripción
var lDescription = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_register' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.03615, fontWeight:'regular' }, color:'#000000', top:lTitle.top + lTitle.height, left:(iImage.left * 2) + iImage.width, right:(iImage.left * 2) + iImage.width, height:(vInformation.height / 3) * 2 });
vInformation.add( lDescription );
sContent.add( vInformation );

// Registro //

// Clase para el formulario
var aForm = new form( sContent, vInformation.top + vInformation.height );

// Creamos todos los campos
var tName = aForm.addField({ name:getLocatedString( 'text_name' ), hintText:getLocatedString( 'text_name' ), defaultValue:sName }, { required:true, min_length:3, max_length:30 });
var tLastName = aForm.addField({ name:getLocatedString( 'text_surname' ), hintText:getLocatedString( 'text_surname' ), defaultValue:sLastName }, { required:true, min_length:3, max_length:50 });
var tBirthday = aForm.addCombo({ name:getLocatedString( 'text_birthdate' ), hintText:sBirthday, defaultValue:sBirthday, type:'date' }, { required:true });
if( ! bDistributor )
{
	//var tDNI = aForm.addField({ name:getLocatedString( 'text_dni' ), hintText:'00000000L', defaultValue:sDNI }, { required:true, min_length:9, max_length:9, regex:/^[0-9]{8}[A-Za-z]$/ });
}
else
{
	var tEnterprise = aForm.addField({ name:getLocatedString( 'text_enterprise' ), hintText:getLocatedString( 'text_enterprise' ), defaultValue:sEnterprise }, { required:true, min_length:3, max_length:50 });
	//var tDNI = aForm.addField({ name:getLocatedString( 'text_cif' ), hintText:'00000000L', defaultValue:sDNI }, { required:true, min_length:9, max_length:9, regex:/^[0-9]{8}[A-Za-z]$/ });
	var tEquivalence = aForm.addCombo({ name:getLocatedString( 'text_charges_equivalence' ), values:[{id:0, value:getLocatedString( 'text_yes' )}, {id:1, value:getLocatedString( 'text_no' )}], defaultValue:sEquivalence }, { required:true });
}
var tEmail = aForm.addField({ name:getLocatedString( 'text_email' ), hintText:'tu@email.com', keyboardType:Titanium.UI.KEYBOARD_EMAIL, defaultValue:sEmail }, { required:true, min_length:6, regex:/^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/ });
var tEmailRepeat = aForm.addField({ name:getLocatedString( 'text_email_repeat' ), hintText:'tu@email.com', keyboardType:Titanium.UI.KEYBOARD_EMAIL, defaultValue:sEmail }, { required:true, min_length:6, regex:/^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/, match:tEmail });
var tAddress = aForm.addField({ name:getLocatedString( 'text_address' ), hintText:getLocatedString( 'text_address' ), defaultValue:sAddress }, { required:true, min_length:10, max_length:100 });
var tCountry = aForm.addCombo({ name:getLocatedString( 'text_country' ), hintText:'España', defaultValue:195, query:'getCountries', change:changeCountry }, { required:true });
var tCP = aForm.addField({ name:getLocatedString( 'text_cp' ), hintText:'11111', keyboardType:Titanium.UI.KEYBOARD_NUMBER_PAD, defaultValue:sCP }, { required:true, min_length:5, max_length:5 });
var tCity = aForm.addField({ name:getLocatedString( 'text_city' ), hintText:'Población', defaultValue:sCity }, { required:true, min_length:3, max_length:50 });
var tState = aForm.addCombo({ name:getLocatedString( 'text_state' ), query:'getZonesByCountry', data:{ parent:'España' }, defaultValue:sState }, { required:true });
var tTelephone = aForm.addField({ name:getLocatedString( 'text_telephone' ), hintText:'Se recomienda móvil', keyboardType:Titanium.UI.KEYBOARD_PHONE_PAD, defaultValue:sTelephone }, { required:true, min_length:9, max_length:20 });
var tPassword = aForm.addField({ name:getLocatedString( 'text_password' ), hintText:'********', passwordMask:true, defaultValue:sPassword }, { required:true, min_length:3, max_length:30 });
var tPasswordRepeat = aForm.addField({ name:getLocatedString( 'text_repeat_password' ), hintText:'********', passwordMask:true, defaultValue:sPassword }, { required:true, min_length:3, max_length:30, match:tPassword });
var tConditions = aForm.addCheckbox({ name:getLocatedString( 'text_terms_conditions' ), text:getLocatedString( 'text_terms_conditions_accept' ), defaultValue:false }, { required:true });
var tBulletin = aForm.addCheckbox({ name:getLocatedString( 'text_bulletin' ), text:getLocatedString( 'text_bulletin_accept' ), defaultValue:false }, { required:false });

// Botón para aceptar
var bContinue = Titanium.UI.createButton({ title:getLocatedString( 'text_continue' ), top:vInformation.left, width:nWidth * 0.7156, height:nHeight * 0.075, backgroundImage:getImage( 'button_account_enter.png' ) });
sContent.add( bContinue );

// Vista para añadir espacio en blanco
var vSpace = Titanium.UI.createView({ top:0, height:vInformation.left, backgroundColor:'transparent' });
sContent.add( vSpace );

// Evento cuando cambia el pais
function changeCountry(e)
{
	// Cambiamos los datos para que salgan las ciudades según el País
	Titanium.App.combo_country = e.selectedValue[0];
	tState.value = -1;
	tState.text = '';
};

// Evento cuando hacemos click en Enviar
bContinue.addEventListener( 'click', function(e)
{
	// Validamos el formulario
	if( aForm.check() )
	{
		// Obtenemos el archivo del carrito
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, 'cart.txt' );

		// Registro de particular
		if( ! bDistributor )
			query({ query:'userRegister', data:{ name:tName.value, lastname:tLastName.value, dob:tBirthday.text, dni:"", email:tEmail.value, address:tAddress.value, cp:tCP.value, country:tCountry.id, state:tState.id, city:tCity.value, telephone:tTelephone.value, password:tPassword.value, cart:(aFile.exists() ? aFile.read().text : false) }, callback:registerCallback });
		// Registro de distribuidor
		else
			query({ query:'userRegisterDistributor', data:{ name:tName.value, lastname:tLastName.value, dob:tBirthday.text, company:tEnterprise.value, dni:tDNI.value, recargo_equivalencia:tEquivalence.id, email:tEmail.value, address:tAddress.value, cp:tCP.value, country:tCountry.id, state:tState.id, city:tCity.value, telephone:tTelephone.value, password:tPassword.value, cart:(aFile.exists() ? aFile.read().text : false) }, callback:registerCallback });

		function registerCallback(aResult, aLoading)
		{
			// Si el usuario ya existe
			if( aResult['userid'] == -2 )
			{
				// Informamos
				Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_message' ), message:getLocatedString( 'message_error_user_exists' ).replace( '%s', tEmail.value ), buttonNames:['Aceptar'] }).show();

				return false;
			}
			// Si ha habido problemas
			if( aResult['userid'] == -1 )
			{
				// Informamos
				Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_message' ), message:getLocatedString( 'message_error_register' ), buttonNames:['Aceptar'] }).show();

				return false;
			}

			// Establecemos los datos
			aUser.setUserid( aResult['userid'] );
			aUser.setEmail( tEmail.value );
			aUser.setUsername( tName.value );
			aUser.setPassword( tPassword.value );

			// Marcamos al usuario como logueado
			aUser.setLogged( true );

			// Si es un distribuidor informamos que debe enviar un documento
			if( bDistributor )
				Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_message' ), message:getLocatedString( 'message_register_distributor_success' ), buttonNames:['Aceptar'] }).show();

			// Mostramos mensaje de bienvenida
			Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_message' ), message:getLocatedString( 'text_welcome' ) + ' ' + aUser.getUsername() + '!', buttonNames:['Aceptar'] }).show();

			// Guardamos al usuario en la sesión
			Titanium.App.User = aUser;

			// Eliminamos el carrito local
			if( aFile.exists() )
				aFile.deleteFile();

			// Liberamos la ventana de carga
			if( aLoading != undefined )
				aLoading.hide();

			// Llamamos a la función para mostrar las opciones
			Titanium.App.fireEvent( 'myAccount', {} );

			// Cerramos la ventana
			Titanium.UI.currentWindow.close();
		}
	}
});