Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

// Cálculo de tamaños //

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Calculamos el ancho y alto según la densidad
if( Titanium.Platform.osname == 'android' )
{
	// Ancho y alto según densidad
	nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
}

// Registro particular //

// Creamos la vista para el bloque
var vParticular = Titanium.UI.createView({ left:nWidth * 0.05312, right:nWidth * 0.05312, top:Titanium.App.top + (nWidth * 0.05312), height:nHeight * 0.19166667, backgroundImage:getImage( 'account_title.png' ), borderRadius:4 });
// Creamos la imágen izquierda
var iImage =  Titanium.UI.createImageView({ image:getImage( 'account_register_on.png' ), width:nWidth * 0.08437, height:nWidth * 0.08437, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
vParticular.add( iImage );
// Creamos el label del titulo
var lTitle = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_register_particular' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.05625, fontWeight:'bold' }, color:'#ffe095', top:iImage.left, left:(iImage.left * 2) + iImage.width, height:vParticular.height / 4 });
vParticular.add( lTitle );
// Creamos el label de descripción
var lDescription = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_register_particular_detail' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.03615, fontWeight:'regular' }, color:'#ffe095', top:lTitle.top + lTitle.height, left:(iImage.left * 2) + iImage.width, right:(iImage.left * 2) + iImage.width, height:(vParticular.height / 3) * 2 });
vParticular.add( lDescription );
// Creamos el area clicable
var vTopParticular = Titanium.UI.createView({ left:0, right:0, top:0, bottom:0, backgroundColor:'transparent' });
vParticular.add( vTopParticular );
Titanium.UI.currentWindow.add( vParticular );

// Evento cuando hacemos click en registro particular
vTopParticular.addEventListener( 'click', function(e)
{
	// Abrimos la ventana de registro particular
	var wWindow = Titanium.UI.createWindow({ title:getLocatedString( 'message_window_register_particular' ), backgroundImage:getImage( 'background.png' ), backgroundColor:'#383b3d', url:'account_register.js', windowParent:Titanium.UI.currentWindow });

	// Abrimos la ventana
	openWindowInTab( wWindow );

	// Evento cuando se cierra la ventana
	wWindow.addEventListener( 'close', function(e)
	{
		// Si el usuario está logueado cerramos la ventana actual también
		if( Titanium.App.User.isLogged() )
			Titanium.UI.currentWindow.close();
	});
});

// Registro distribuidor //

// Creamos la vista para el bloque
var vDistributor = Titanium.UI.createView({ left:nWidth * 0.05312, right:nWidth * 0.05312, top:vParticular.top + vParticular.height + (nHeight * 0.0625), height:vParticular.height * 2.2, backgroundColor:'#3585ce', borderRadius:4 });
// Creamos la imágen izquierda
var iImage =  Titanium.UI.createImageView({ image:getImage( 'account_register_distributor.png' ), width:nWidth * 0.08437, height:nWidth * 0.08437, left:nWidth * 0.03125, top:nWidth * 0.03125, backgroundColor:'transparent', hires:true });
vDistributor.add( iImage );
// Creamos el label del titulo
var lTitle = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_register_professional' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.05625, fontWeight:'bold' }, color:'#ffffff', top:iImage.left, left:(iImage.left * 2) + iImage.width, height:vDistributor.height / 8 });
vDistributor.add( lTitle );
// Creamos el label de descripción
var lDescription = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_register_professional_detail' ), font:{ fontName:'Helvetica Neue', fontSize:nWidth * 0.03615, fontWeight:'regular' }, color:'#ffffff', top:lTitle.top + lTitle.height, left:(iImage.left * 2) + iImage.width, right:(iImage.left * 2) + iImage.width, height:(vDistributor.height / 4) * 2.1 });
vDistributor.add( lDescription );
// Creamos la imágen de advertencia
var iWarning =  Titanium.UI.createImageView({ image:getImage( 'icon_warning.png' ), width:nWidth * 0.040625, height:nHeight * 0.025, left:lDescription.left - (nWidth * 0.040625) - 5, top:lDescription.top + lDescription.height, backgroundColor:'transparent', hires:true });
vDistributor.add( iWarning );
// Creamos el label para la letra pequeña
var lDescription2 = Titanium.UI.createLabel({ text:getLocatedString( 'message_window_register_professional_detail2' ), font:{ fontName:'Helvetica Neue', fontSize:lDescription.font.fontSize / 1.2, fontWeight:'regular' }, color:'#ffffff', top:lDescription.top + lDescription.height, left:lDescription.left, height:'auto' });
vDistributor.add( lDescription2 );
// Creamos el area clicable
var vTopDistributor = Titanium.UI.createView({ left:0, right:0, top:0, bottom:0, backgroundColor:'transparent' });
vDistributor.add( vTopDistributor );
Titanium.UI.currentWindow.add( vDistributor );

// Evento cuando hacemos click en registro distribuidor
vTopDistributor.addEventListener( 'click', function(e)
{
	// Abrimos la ventana de registro particular
	var wWindow = Titanium.UI.createWindow({ title:getLocatedString( 'message_window_register_professional' ), distributor:true, backgroundImage:getImage( 'background.png' ), backgroundColor:'#383b3d', url:'account_register.js', windowParent:Titanium.UI.currentWindow });

	// Abrimos la ventana
	openWindowInTab( wWindow );

	// Evento cuando se cierra la ventana
	wWindow.addEventListener( 'close', function(e)
	{
		// Si el usuario está logueado cerramos la ventana actual también
		if( Titanium.App.User.isLogged() )
			Titanium.UI.currentWindow.close();
	});
});