Titanium.include( 'config.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/functions/location.js' );
Titanium.include( '/classes/analytics.class.js' );
Titanium.include( '/classes/saves.class.js' );
Titanium.include( '/classes/user.class.js' );
Titanium.include( 'database.js' );


// Hacemos una consulta para obtener la configuración
query({ query:'getConfig', showLoading:false, callback:function(aResult)
{
	// Variables de configuración //

	// Recorremos las variables de configuración y las añadimos
	for( var nCont = 0; nCont < aResult.length; nCont++ )
		eval( 'Titanium.App.' + aResult[nCont].key + ' = aResult[nCont].value;' );

	// Google Analytics //

	// Si tenemos analytics key
	if( Titanium.App.analytics_key !== false )
	{
		// Creamos la instancia de Analytics
		var analytics = new Analytics( Titanium.App.analytics_key );

		// Guardamos la página que se ha lanzado
		Titanium.App.addEventListener( 'analytics_trackPageview', function(e){ analytics.trackPageview( '/' + Titanium.Platform.osname + e.pageUrl ); });
		// Guardamos el evento que se ha lanzado
		Titanium.App.addEventListener( 'analytics_trackEvent', function(e){	analytics.trackEvent( e.category, e.action, e.label, e.value ); });
		// Evento que se lanza cuando cerramos una app
		Titanium.App.addEventListener( 'close', function(e){ analytics.stop(); });

		// Establecemos como globales las analytics para poder recoger más fácilmente los eventos
		Titanium.App.Analytics = { trackPageview: function(pageUrl){ Titanium.App.fireEvent( 'analytics_trackPageview', {pageUrl:pageUrl} ); },	trackEvent:function(category, action, label, value){ Titanium.App.fireEvent( 'analytics_trackEvent', {category:category, action:action, label:label, value:value} ); } }

		// Iniciamos las estadísticas
		analytics.start( 10 );
	}

	// Quitamos el badge de la app
	if( ! Titanium.App.isAndroid )
		Titanium.UI.iPhone.appBadge = null;

	// Creamos el objeto CSS y lo dejamos como global
	aUser = new User();
	Titanium.App.User = aUser;

	// Login //

	// Creamos el objeto user y lo dejamos como global
	aUser = new User();
	Titanium.App.User = aUser;
	Titanium.App.reloadCart = true;

	// Favoritos y carrito //

	// Favoritos
	var aSavesFavorites = new Saves( 'favorites' );
	var nBadgeFavorites = aSavesFavorites.getBadge();

	// Carrito
	var aSavesCart = new Saves( 'cart' );
	var nBadgeCart = aSavesCart.getBadge();

	// Si la app es multiidioma
	if( Titanium.App.multilanguage == true ) 
	{
		// Obtenemos el archivo de configuración de idioma
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, 'lang.txt' );

		// Si existe el archivo
		if( aFile.exists() )
		{
			// Modo lectura
			aFile.open( Titanium.Filesystem.MODE_READ );

			// Separamos el texto del idioma de su codigo
			var aLang = aFile.read().text.split( ':' );

			// Establecemos el idioma seleccionado
			Titanium.App.language = aLang[0];
			Titanium.App.idlanguage = aLang[1];

			// Cargamos la APP
			loadAPP();
		}
		// Si no existe
		else
		{
			// Abrimos la ventana para seleccionar idioma
			var wLang = Titanium.UI.createWindow({ title:'Idiomas', backgroundImage:getImage( 'languages_select' + (Titanium.Platform.displayCaps.platformHeight >= 1000 ? '@2x' : '') + '.png' ), navBarHidden:true, exitOnClose:true, url:'languages.js', navBarHidden:true });
			wLang.addEventListener( 'close', loadAPP );
			wLang.open();
		}
	}
	// Si no es multiidioma, cargamos la APP
	else
		loadAPP();

	function loadAPP()
	{
		// Ventanas //

		// Creamos la ventana de inicio
		var wHome = Titanium.UI.createWindow({ title:getLocatedString( 'window_home' ), backgroundImage:getImage( 'background.png' ), navBarHidden:true, exitOnClose:true, url:'home.js' });
		// Creamos la ventana de favoritos
		var wFavorites = Titanium.UI.createWindow({ type:'favorites', title:getLocatedString( 'window_favorites' ), backgroundColor:'#ffffff', navBarHidden:true, exitOnClose:true, url:'products.js' });
		// Creamos la ventana del carrito
		var wCart = Titanium.UI.createWindow({ type:'cart', title:getLocatedString( 'window_cart' ), backgroundColor:'#ffffff', exitOnClose:true, url:'cart.js', navBarHidden:true });
		// Creamos la ventana del usuario
		var wAccount = Titanium.UI.createWindow({ title:getLocatedString( 'window_my_account' ), backgroundImage:getImage( 'background.png' ), backgroundColor:'#383b3d', exitOnClose:true, url:'account.js', navBarHidden:true });
		// Creamos la ventana de tiendas
		var wStores = Titanium.UI.createWindow({ title:getLocatedString( 'window_contact' ), backgroundImage:getImage( 'background.png' ), backgroundColor:'#383b3d', exitOnClose:true, url:'contact.js', navBarHidden:true });

		// Tabs //

		// Creamos el tab del inicio
		var tHome = Titanium.UI.createTab({ icon:getImage( 'tab1.png' ), title:getLocatedString( 'window_home' ), window:wHome });
		// Creamos el tab de los favoritos
		var tFavorites = Titanium.UI.createTab({ icon:getImage( 'tab2.png' ), title:getLocatedString( 'window_favorites' ), badge:nBadgeFavorites, window:wFavorites });
		// Creamos el tab del carrito
		var tCart = Titanium.UI.createTab({ icon:getImage( 'tab3.png' ), title:getLocatedString( 'window_cart' ), badge:nBadgeCart, window:wCart });
		// Creamos el tab del usuario
		var tAccount = Titanium.UI.createTab({ icon:getImage( 'tab4.png' ), title:getLocatedString( 'window_my_account' ), window:wAccount });
		// Creamos el tab de las tiendas
		var tStores = Titanium.UI.createTab({ icon:getImage( 'tab5.png' ), title:getLocatedString( 'window_contact' ), window:wStores });

		// Creamos el tabgroup
		var tabGroup = Titanium.UI.createTabGroup();

		// Añadimos los tabs
		tabGroup.addTab( tHome );  
		tabGroup.addTab( tFavorites );  
		tabGroup.addTab( tCart );  
		tabGroup.addTab( tAccount );  
		tabGroup.addTab( tStores );  

		// Abrimos el tabgroup
		tabGroup.open();
	}
}});