Titanium.include( 'database.js' );
Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

// TopBar //

// Mostramos el TopBar
new topBar({}).show();

// Hacemos una consulta para obtener las categorías principales
query({ query:'getMainCategories', data:{ language:Titanium.App.idlanguage }, callback:function(aResult)
	{
		// Si obtenemos un resultado correcto
		if( aResult !== false )
		{
			// Cálculo de tamaños //

			var nWidth = Titanium.Platform.displayCaps.platformWidth;
			var nHeight = Titanium.Platform.displayCaps.platformHeight;

			// Calculamos el ancho y alto según la densidad
			if( Titanium.Platform.osname == 'android' )
			{
				// Ancho y alto según densidad
				nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
				nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			}

			// Catálogo //

			// Creamos la tabla para mostrar las categorías principales
			var tTable = Titanium.UI.createTableView({ separatorStyle:0, backgroundColor:'transparent' });
			css( tTable, 'catalog_table' );

			// Array de datos
			var aData = [];

			// Recorremos el resultado y lo añadimos a la tabla
			for( var nCont = 0; nCont < aResult.length; nCont++ )
			{
				// Obtenemos la imágen
				sImage = encodeURI( Titanium.App.images + 'imagenes/categorias/' + aResult[nCont].idcategory + '.png' );

				// Creamos la fila
				var aRow = Titanium.UI.createTableViewRow({ id:aResult[nCont].idcategory, text:aResult[nCont].category, sons:aResult[nCont].sons > 0, className:'catalog', backgroundColor:'transparent', backgroundSelectedColor:'transparent', hasChild:false });
				css( aRow, 'catalog_table_row' );
				var aRowSpace = Titanium.UI.createTableViewRow({ id:'none', className:'sections_none', backgroundColor:'transparent', hasChild:false });
				css( aRowSpace, 'catalog_table_row_space' );

				// Bordes de la fila
				var iBorder = Titanium.UI.createView({ backgroundColor:'#000000', borderColor:'#ddc559', borderWidth:1, borderRadius:4 });
				aRow.add( iBorder );
				aRow.row_border = iBorder;
				// Creamos la imagen izquierda
				var iImage =  Titanium.UI.createImageView({ image:sImage, backgroundColor:'transparent', hires:true });
				css( iImage, 'catalog_table_row_image' );
				aRow.add( iImage );
				// Creamos el label del titulo
				var lTitle = Titanium.UI.createLabel({ text:aResult[nCont].category, minimumFontSize:2, font:{ fontSize:wPer( 25 ), fontWeight:'bold', fontFamily:'Helvetica Neue' }, color:'#ddc559', textAlign:'left', left:nWidth / 3, right:nWidth / 5, height:aRow.height });
				css( lTitle, 'catalog_table_row_title' );
				aRow.add( lTitle );
				aRow.row_title = lTitle;
				// Creamos la flecha derecha
				var iArrow = Titanium.UI.createImageView({ image:getImage( 'row_arrow_off.png' ), right:wPer( 30 ), width:wPer( 16 ), height:wPer( 25 ) });
				aRow.add( iArrow );
				aRow.row_arrow = iArrow;

				// Añadimos la fila a los datos
				aData.push( aRow );
				aData.push( aRowSpace );
			}

			// Añadimos los datos a la tabla
			tTable.setData( aData );

			// Añadimos la tabla
			Titanium.UI.currentWindow.add( tTable );

			// Evento cuando pulsamos en un elemento de la lista
			tTable.addEventListener('touchstart', function(e)
			{
				// Cambiamos los colores
				if( e.rowData.row_border != undefined )
				{
					e.rowData.row_border.backgroundColor = '#ddc559';
					e.rowData.row_title.color = '#000000';
					e.rowData.row_arrow.image = getImage( 'row_arrow_on.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchend', function(e)
			{
				// Cambiamos los colores
				if( e.rowData.row_border != undefined )
				{
					e.rowData.row_border.backgroundColor = '#000000';
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchcancel', function(e)
			{
				// Cambiamos los colores
				if( e.rowData.row_border != undefined )
				{
					e.rowData.row_border.backgroundColor = '#000000';
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando hacemos click en un elemento de la lista
			tTable.addEventListener('click', function(e)
			{
				// Si pulsamos en un espacio de la tabla
				if( e.rowData.id == 'none' )
					return false;

				// Abrimos la ventana de categorias si tenemos subcategorías
				if( e.rowData.sons )
					var wWindow = Titanium.UI.createWindow({ id:e.rowData.id, title:e.rowData.text, backgroundImage:getImage( 'background.png' ), backgroundColor:'transparent', url:'categories.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true });
				// Abrimos la ventana de productos si no tenemos subcategorías
				else
					var wWindow = Titanium.UI.createWindow({ type:'products', id:e.rowData.id, title:e.rowData.text, backgroundImage:getImage( 'background.png' ), backgroundColor:'transparent', url:'products.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true });

				// Abrimos la ventana
				openWindowInTab( wWindow );
			});
		}
	}
});