Titanium.include( 'database.js' );
Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

// Mostramos el TopBar
new topBar({}).show();

// Hacemos una consulta para obtener las categorias
query({ query:'getCategoriesByParent', data:{ idcategory:Titanium.UI.currentWindow.id, language:Titanium.App.idlanguage }, callback:function(aResult)
	{
		// Si obtenemos un resultado correcto
		if( aResult !== false )
		{
			// Cálculo de tamaños

			var nWidth = Titanium.Platform.displayCaps.platformWidth;
			var nHeight = Titanium.Platform.displayCaps.platformHeight;

			// Calculamos el ancho y alto según la densidad
			if( Titanium.Platform.osname == 'android' )
			{
				// Ancho y alto según densidad
				nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
				nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			}

			var nRowSize = (nHeight - Titanium.App.topBarSize - Titanium.App.tabGroupSize) / 5;

			// Categorías //

			// Creamos la tabla para mostrar las categorías
			var tTable = Titanium.UI.createTableView({ top:Titanium.App.top, bottom:Titanium.App.bottom, separatorStyle:0, backgroundColor:'transparent' });

			// Array de datos
			var aData = [];

			// Recorremos el resultado y lo añadimos a la tabla
			for( var nCont = 0; nCont < aResult.length; nCont++ )
			{
				// Si no tiene productos continuamos
				//if( aResult[nCont].quantity == 0 )
					//continue;

				// Creamos la fila
				var aRow = Titanium.UI.createTableViewRow({ id:aResult[nCont].idcategory, text:aResult[nCont].category, subcategory:aResult[nCont].subcategory, height:nRowSize, className:'categories', backgroundColor:'#000000', hasChild:false });
				css( aRow, 'categories_table_row' );
				var aRowSpace = Titanium.UI.createImageView({ left:0, right:0, bottom:0, width:nWidth, height:1, backgroundColor:'#ddc559' });
				aRow.add( aRowSpace );
				if( nCont == 0 )
				{
					var aRowSpace = Titanium.UI.createImageView({ left:0, right:0, top:0, width:nWidth, height:1, backgroundColor:'#ddc559' });
					aRow.add( aRowSpace );
				}

				// Creamos la imágen de la categoría
				if( aResult[nCont].image != '' )
				{
					var aImage = Titanium.UI.createImageView({ image:Titanium.App.images.replace( 'productos', 'categorias' ) + aResult[nCont].image, backgroundColor:'transparent', hires:true });
					css( aImage, 'categories_table_row_image' );
					aRow.add( aImage );
				}
				// Creamos el label del titulo
				var lTitle = Titanium.UI.createLabel({ text:aResult[nCont].category, font:{ fontSize:nRowSize / 5, fontWeight:'bold' }, minimumFontSize:3, color:'#ddc559', left:20, top:5, bottom:5, right:20, textAlign:'left' });
				lTitle.left = (aResult[nCont].image != '' ? ((nHeight - Titanium.App.topBarSize - Titanium.App.tabGroupSize) / 5) : wPer( 20 ));
				aRow.row_title = lTitle;
				//css( lTitle, 'categories_table_row_title' );
				// Creamos el label del cantidad de productos
				var lProducts = Titanium.UI.createLabel({ text:parseInt( aResult[nCont].quantity ) + ' producto' + (aResult[nCont].quantity == 1 ? '' : 's'), font:{ fontSize:nRowSize / 5, fontWeight:'bold' }, color:'#ffffff', height:nRowSize / 4, left:20, bottom:5, right:20, textAlign:'left' });
				lProducts.left = (aResult[nCont].image != '' ? ((nHeight - Titanium.App.topBarSize - Titanium.App.tabGroupSize) / 5) : wPer( 20 ));
				// Creamos la flecha derecha
				var iArrow = Titanium.UI.createImageView({ image:getImage( 'row_arrow_off.png' ), right:wPer( 30 ), width:wPer( 16 ), height:wPer( 25 ) });
				aRow.add( iArrow );
				aRow.row_arrow = iArrow;

				// Añadimos los objetos a la fila
				aRow.add( lTitle );
				aRow.add( lProducts );

				// Añadimos la fila a los datos
				aData.push( aRow );
			}

			// Añadimos los datos a la tabla
			tTable.setData( aData );

			// Añadimos la tabla
			Titanium.UI.currentWindow.add( tTable );

			// Evento cuando pulsamos en un elemento de la lista
			tTable.addEventListener('touchstart', function(e)
			{
				// Cambiamos los colores
				if( e.rowData.row_title != null )
				{
					e.rowData.row_title.color = '#000000';
					e.rowData.row_arrow.image = getImage( 'row_arrow_on.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchend', function(e)
			{
				// Cambiamos los colores
				if( e.rowData.row_title != null )
				{
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchcancel', function(e)
			{
				// Cambiamos los colores
				if( e.rowData.row_title != null )
				{
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando hacemos click en un elemento de la lista
			tTable.addEventListener('click', function(e)
			{
				// Si tenemos subcategorias abrimos la ventana de categorias
				if( e.rowData.subcategory == true )
				{
					// Abrimos la ventana de categorias
					var wCategories = Titanium.UI.createWindow({ id:e.rowData.id, title:e.rowData.text, url:'categories.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true });

					// Abrimos la ventana
					openWindowInTab( wCategories );
				}
				// Si no tenemos más subcategorías abrimos la ventana de productos
				else
				{
					// Abrimos la ventana de productos
					var wProducts = Titanium.UI.createWindow({ type:'products', id:e.rowData.id, title:e.rowData.text, backgroundColor:'#ffffff', url:'products.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true });

					// Abrimos la ventana
					openWindowInTab( wProducts );
				}
			});
		}
	}
});