Titanium.include( '/database.js' );
Titanium.include( '/functions/css.js' );

function form(aParent, nFormTop)
{
	var self = this;

	// Propiedades
	var aFields = [];
	var aPicker = undefined;
	var nLabelHeight = false;
	var nFieldHeight = false;

	this.addField = function(aParams, aValidator)
	{
		// Cálculo de tamaños //
		var nWidth = Titanium.Platform.displayCaps.platformWidth;
		var nHeight = Titanium.Platform.displayCaps.platformHeight;

		// Label
		var lLabel = Titanium.UI.createLabel({ text:aParams.name + ':', font:{ fontSize:nWidth * 0.0453, fontWeight:'bold' }, left:nWidth * 0.07812, right:nWidth * 0.07812, top:nHeight * 0.010416667, height:nHeight * 0.041666667 });
		css( lLabel, 'field_label' );
		aParent.add( lLabel );

		// Si no tenemos el tamaño de los label
		if( nLabelHeight === false )
		{
			// Obtenemos el alto de los campos en iOS
			if( ! Titanium.App.isAndroid )
			{
				var aAux = lLabel.toImage();
				nLabelHeight = lLabel.top + aAux.height;
			}
			// Obtenemos el alto de los campos en Android
			else
				nLabelHeight = lLabel.top + wPer( 10 );
		}

		// Obtenemos los parámetros
		aParams['value'] = (aParams.hasOwnProperty( 'defaultValue' ) ? aParams.defaultValue : '');
		aParams['color'] = '#312f2f';
		aParams['left'] = lLabel.left;
		aParams['right'] = lLabel.left;
		aParams['height'] = (aParams.hasOwnProperty( 'height' ) ? aParams.height : nHeight * 0.077);
		aParams['top'] = 0;
		aParams['borderRadius'] = 5;
		aParams['borderWidth'] = 1;
		aParams['borderColor'] = '#b1b1b1';
		aParams['paddingLeft'] = 10;
		aParams['suppressReturn'] = true;
		aParams['backgroundImage'] = 'none';
		aParams['autocorrect'] = false;
		if( aParams.hasOwnProperty( 'keyboardType' ) && aParams['keyboardType'] == Titanium.UI.KEYBOARD_EMAIL )
			aParams['autocapitalization'] = Titanium.UI.TEXT_AUTOCAPITALIZATION_NONE;

		// TextField
		if( ! aParams.hasOwnProperty( 'field_type' ) || ( aParams.hasOwnProperty( 'field_type' ) && aParams.field_type == 'textfield' ) )
			var tField = Titanium.UI.createTextField( aParams );
		// TextArea
		else if( aParams.hasOwnProperty( 'field_type' ) && aParams.field_type == 'textarea' )
			var tField = Titanium.UI.createTextArea( aParams );

		css( tField, 'field_object' );
		aParent.add( tField );

		// Si no tenemos el tamaño de los fields
		if( nFieldHeight === false )
			nFieldHeight = tField.top + tField.height;

		// Añadimos a la lista de campos
		aFields[aFields.length] = { field:tField, validator:aValidator };

		// Evento click del campo //

		// Evento cuando hacemos click en la caja de texto
		tField.addEventListener( 'focus', function(e)
		{
			// Cerramos el picker si hubiera uno abierto
			self.closePicker();

			// Hacemos scroll hasta el campo
			self.scrollTo( e.source );
		});

		// Retornamos el campo
		return tField;
	};

	this.scrollTo = function(aField)
	{
		// Obtenemos el top //

		var nTop = nFormTop;

		// Recorremos los campos y calculamos el top
		for( var nCont = 0; nCont < aFields.length; nCont++ )
		{
			// Si el campo no es el que queremos mostrar obtenemos su posicion
			if( aFields[nCont].field != aField )
				nTop += nLabelHeight + nFieldHeight;
			// Si queremos mostrar el campo paramos
			else
				break;
		}

		// Hacemos scroll a la posición obtenida
		//aParent.scrollTo( 0, nTop );
	};

	this.addCombo = function(aParams, aValidator)
	{
		// Cálculo de tamaños //
		var nWidth = Titanium.Platform.displayCaps.platformWidth;
		var nHeight = Titanium.Platform.displayCaps.platformHeight;

		// Label
		var lLabel = Titanium.UI.createLabel({ text:aParams.name + ':', font:{ fontSize:nWidth * 0.0453, fontWeight:'bold' }, color:'#5b3078', left:nWidth * 0.07812, right:nWidth * 0.07812, top:nHeight * 0.010416667, height:nHeight * 0.041666667, opened:false });
		css( lLabel, 'field_label' );
		aParent.add( lLabel );

		// Si no tenemos el tamaño de los label
		if( nLabelHeight === false )
		{
			// Obtenemos el alto de los campos en iOS
			if( ! Titanium.App.isAndroid )
			{
				var aAux = lLabel.toImage();
				nLabelHeight = aAux.top + aAux.height;
			}
			// Obtenemos el alto de los campos en Android
			else
				nLabelHeight = lLabel.top + wPer( 10 );
		}

		// Contenedor del combobox
		var vCombo = Titanium.UI.createView({ left:lLabel.left, right:lLabel.left, top:0, height:nHeight * 0.077, backgroundColor:'#ddcbf3', borderRadius:5, borderWidth:1, borderColor:'#b1b1b1' });
		css( vCombo, 'field_object' );
		aParent.add( vCombo );
		// Imágen del combobox
		var iCombo = Titanium.UI.createImageView({ image:getImage( 'combobox.png' ), right:0, top:0, height:vCombo.height, width:nWidth * 0.125, backgroundColor:'transparent', hires:true });
		vCombo.add( iCombo );
		// Label del combobox
		var lCombo = Titanium.UI.createLabel({ id:(aParams.hasOwnProperty( 'defaultValue' ) ? aParams.defaultValue : ''), text:(aParams.hasOwnProperty( 'hintText' ) ? aParams.hintText : ''), color:'#312f2f', left:nWidth * 0.03125, right:iCombo.width + (nWidth * 0.03125), top:0, height:vCombo.height, borderWidth:0, backgroundColor:'#ddcbf3' });
		css( lCombo, 'field_object' );
		vCombo.add( lCombo );

		// Combobox
		var vCombobox = Titanium.UI.createView({ name:aParams.name, label:lCombo, left:0, right:0, top:0, bottom:0, backgroundColor:'transparent' });
		vCombo.add( vCombobox );

		// Si no tenemos el tamaño de los fields
		if( nFieldHeight === false )
			nFieldHeight = vCombobox.top + vCombobox.height;

		// Añadimos a la lista de campos
		aFields[aFields.length] = { field:vCombobox, validator:aValidator };

		// Evento click del combo //

		// Evento cuando hacemos click en el combo
		vCombobox.addEventListener( 'click', function(e)
		{
			// Si el combo no está activado retornamos false
			if( aParams.hasOwnProperty( 'enabled' ) && aParams.enabled === false )
				return false;

			// Cerramos todas las cajas de texto
			for( var nCont = 0; nCont < aFields.length; nCont++ )
				if( aFields[nCont].field.toString() == '[object TiUITextField]' || aFields[nCont].field.toString() == '[object TextField]' )
					aFields[nCont].field.blur();

			// Cerramos el Picker
			if( self.aPicker != undefined )
			{
				self.aPicker.label.opened = false;
				Titanium.UI.currentWindow.remove( self.aPicker );
				self.aPicker = undefined;
			}

			// Hacemos scroll hasta el campo
			self.scrollTo( e.source );

			// Si tenemos una consulta
			if( aParams.hasOwnProperty( 'query' ) )
			{
				// Ejecutamos la consulta
				query({ query:aParams.query, data:(aParams.hasOwnProperty( 'data' ) ? (Titanium.App.combo_country ? {parent: Titanium.App.combo_country} : aParams.data) : {}), callback:function(aResult)
				{
					self.showPicker({ values:aResult, source:e.source.label, type:'normal', change:aParams.change });
				}});
			}
			// Si tenemos valores estáticos
			else if( aParams.hasOwnProperty( 'values' ) )
				self.showPicker({ values:aParams.values, source:e.source.label, type:'normal', change:aParams.change });
			// Si tenemos un tipo
			else if( aParams.hasOwnProperty( 'type' ) )
				self.showPicker({ source:e.source.label, type:aParams.type, change:aParams.change });
		});

		// Retornamos el campo
		return lCombo;
	};

	this.showPicker = function(aParams)
	{
		// Si ya hay un picker abierto no hacemos nada
		if( aParams.source.opened )
			return false;

		// Variables
		var aData = [];
		var nSel = 0;

		// Creamos la vista para el picker
		self.aPicker = Titanium.UI.createView({ label:aParams.source, height:(Titanium.App.isAndroid ? 164 + (nHeight * 0.0916) : (480 * 0.5416)), bottom:(Titanium.App.isAndroid ? -(164 + (nHeight * 0.0916)) : -(480 * 0.5416)), backgroundColor:'transparent' });
		Titanium.UI.currentWindow.add( self.aPicker );

		// Creamos la barra de tareas
		var vToolBar = Titanium.UI.createView({ top:0, height:nHeight * 0.0916, backgroundColor:(Titanium.App.isAndroid ? 'transparent' : '#000000'), opacity:0.3 });
		self.aPicker.add( Titanium.UI.createView({ top:0, height:1, backgroundColor:'#343434' }) );
		self.aPicker.add( Titanium.UI.createView({ top:1, height:1, backgroundColor:'#b8b8b8' }) );
		self.aPicker.add( vToolBar );

		// Si estamos en Android añadimos el fondo con opacidad reducida
		if( Titanium.App.isAndroid )
			self.aPicker.backgroundImage = getImage( 'picker_background.png' );

		// Creamos el botón de OK
		var bPickerOK = showButton( 'OK', { right:(nWidth * 0.010416667), top:(vToolBar.height / 2) - ((nHeight * 0.0625) / 2) }, self.closePicker );
		self.aPicker.add( bPickerOK );

		// Si es de tipo normal
		if( aParams.type == 'normal' )
		{
			// Rellenamos los datos
			for( var nCont = 0; nCont < aParams.values.length; nCont++ )
			{
				// Añadimos la fila
				aData.push( Titanium.UI.createPickerRow({ value:aParams.values[nCont].id, title:aParams.values[nCont].value }) );

				// Si el valor añadido es el seleccionado nos quedamos con el índice
				if( aParams.values[nCont].value == aParams.source.text )
					nSel = nCont;
			}

			// Si no hemos obtenido resultado añadimos una fila vacía
			if( aParams.values.length == 0 )
				aData.push( Titanium.UI.createPickerRow({ value:-1, title:'-' }) );

			// Creamos el picker
			pPicker = Titanium.UI.createPicker({ bottom:0, selectionIndicator:true, useSpinner:true, field:aParams.source.text });
			pPicker.add( aData );
			self.aPicker.add( pPicker );

			// Seleccionamos el valor en el picker
			pPicker.setSelectedRow( 0, nSel );
		}
		// Si es de tipo date
		else if( aParams.type == 'date' )
		{
			// Creamos el picker de fecha
			pPicker = Titanium.UI.createPicker({ bottom:0, selectionIndicator:true, useSpinner:true, field:aParams.source.text, type:Titanium.UI.PICKER_TYPE_DATE });
			self.aPicker.add( pPicker );

			// Seleccionamos el valor en el picker
			pPicker.setSelectedRow( 0, nSel );
		}

		// Mostramos el picker
		self.aPicker.animate( Titanium.UI.createAnimation({ bottom:0 }) );

		// Indicamos que el label está abierto
		aParams.source.opened = true;

		// Evento cuando cambiamos de valor con el picker
		pPicker.addEventListener( 'change', function(e)
		{
			// Actualizamos el campo //

			// Si es de tipo normal
			if( aParams.type == 'normal' )
			{
				aParams.source.text = e.selectedValue[0];
				aParams.source.id = e.row.value;
			}
			// Si es de tipo fecha
			else if( aParams.type == 'date' )
			{
				// Descomponemos la fecha
				var aDate = new Date( e.value );

				// Mostramos la fecha
				aParams.source.text = aDate.getDate() + '/' + ((aDate.getMonth() + 1) < 10 ? '0' : '') + (aDate.getMonth() + 1) + '/' + aDate.getFullYear();
			}

			// Si tenemos evento change lo llamamos
			if( aParams.change )
				aParams.change( e );
		});

		return self.aPicker;
	};

	this.closePicker = function(e)
	{
		// Si tenemos un Picker
		if( self.aPicker != undefined )
		{
			// Creamos la animación para ocultar el picker
			var aAnimation = Titanium.UI.createAnimation({ bottom:-self.aPicker.height });

			// Cuando la animación se complete liberamos el picker
			aAnimation.addEventListener( 'complete', function(){ Titanium.UI.currentWindow.remove( self.aPicker ); self.aPicker = undefined; } );

			// Ocultamos el picker
			self.aPicker.animate( aAnimation );

			// Indicamos que el label está cerrado
			self.aPicker.label.opened = false;
		}
	};

	this.addCheckbox = function(aParams, aValidator)
	{
		// Cálculo de tamaños //
		var nWidth = Titanium.Platform.displayCaps.platformWidth;
		var nHeight = Titanium.Platform.displayCaps.platformHeight;

		// Obtenemos los parámetros
		aParams['value'] = (aParams.hasOwnProperty( 'defaultValue' ) ? aParams.defaultValue : false);
		aParams['left'] = nWidth * 0.07812;
		aParams['right'] = nWidth * 0.07812;
		aParams['height'] = nHeight * 0.077;
		aParams['top'] = nHeight * 0.041666667;
		aParams['borderWidth'] = 1;
		aParams['borderColor'] = '#707070';
		aParams['borderRadius'] = 5;
		aParams['borderWidth'] = 0;
		aParams['backgroundColor'] = '#e5e5e5';

		// Combobox
		var tField = Titanium.UI.createView( aParams );
		css( tField, 'field_object' );
		// Texto del combobox
		var lField = Titanium.UI.createLabel({ text:aParams.text, font:{ fontSize:nWidth * 0.0421875, fontWeight:'regular' }, left:nWidth * 0.03125, right:(nWidth * 0.03125) + (nWidth * 0.084375) + (nWidth * 0.03125), top:0, bottom:0, color:'#000000' });
		tField.add( lField );
		// Imágen del combobox
		var iField = Titanium.UI.createImageView({ image:getImage( 'checkbox_' + (aParams['value'] ? 'on' : 'off') + '.png' ), right:nWidth * 0.03125, width:nWidth * 0.084375, height:nWidth * 0.084375 });
		tField.add( iField );
		// Área clicable
		var cField = Titanium.UI.createView({ name:aParams.name, left:0, right:0, top:0, bottom:0, backgroundColor:'transparent', value:(aParams.hasOwnProperty( 'defaultValue' ) ? aParams.defaultValue : false) });
		tField.add( cField );
		aParent.add( tField );

		// Evento cuando hacemos click en el checkbox
		cField.addEventListener( 'click', function(e)
		{
			cField.value = ! cField.value;
			iField.image = getImage( 'checkbox_' + (cField.value ? 'on' : 'off') + '.png' );
		});

		// Añadimos a la lista de campos
		aFields[aFields.length] = { field:cField, validator:aValidator };

		// Retornamos el campo
		return cField;
	};

	this.check = function()
	{
		// Cerramos todas las cajas de texto
		for( var nCont = 0; nCont < aFields.length; nCont++ )
			if( aFields[nCont].field.toString() == '[object TiUITextField]' || aFields[nCont].field.toString() == '[object TextField]' )
				aFields[nCont].field.blur();

		// Cerramos el Picker
		self.closePicker();

		// Mensaje de error
		var sMessageError = '';

		// Recorremos los campos
		for( var nCont = 0; nCont < aFields.length; nCont++ )
		{
			// Mensaje de error
			var sMessage = '';

			// Obtenemos el campo y el validador
			var aField = aFields[nCont].field;
			var aValidator = aFields[nCont].validator;

			// Valor del campo
			var sValue = (aField.value != null ? aField.value : (aField.toString() == '[object TiUITextField]' || aField.toString() == '[object TextField]' ? aField.value : aField.label.text));

			// Hacemos trim al campo
			sValue = sValue.replace(/^\s+/g, '').replace(/\s+$/g, '');

			// Requerido
			if( aValidator.hasOwnProperty( 'required' ) && aValidator.required && ( sValue == '' || sValue == null || sValue == false ) )
				sMessage += '* ' + getLocatedString( 'message_error_form_required' ).replace( '%s', aField.name ) + '\n';

			// Tamaño mínimo
			if( aValidator.hasOwnProperty( 'min_length' ) && sValue.length < aValidator.min_length )
				sMessage += '* ' + getLocatedString( 'message_error_form_small' ).replace( '%s1', aField.name ).replace( '%s2', aValidator.min_length ) + '\n';

			// Tamaño máximo
			if( aValidator.hasOwnProperty( 'max_length' ) && sValue.length > aValidator.max_length )
				sMessage += '* ' + getLocatedString( 'message_error_form_big' ).replace( '%s1', aField.name ).replace( '%s2', aValidator.max_length ) + '\n';

			// Regex
			if( aValidator.hasOwnProperty( 'regex' ) && aValidator.regex.test( sValue ) == false )
				sMessage += '* ' + getLocatedString( 'message_error_form_format' ).replace( '%s', aField.name ) + '\n';

			// Coincidencia
			if( aValidator.hasOwnProperty( 'match' ) )
			{
				// Valor del campo match
				sMatch = (aValidator.match.toString() == '[object TiUITextField]' || aValidator.match.toString() == '[object TextField]' ? aValidator.match.value : aValidator.match.label.text);

				// Comprobamos la coincidencia
				if( sValue != sMatch )
					sMessage += '* ' + getLocatedString( 'message_error_form_match' ).replace( '%s1', aField.name ).replace( '%s2', aValidator.match.name ) + '\n';
			}

			// Si tenemos errores
			if( sMessage != '' )
			{
				if( ! Titanium.App.isAndroid )
				{
					aField.borderWidth = 2;
					aField.borderColor = '#ff2525';
				}
			}
			// Si no tenemos errores
			else
			{
				if( ! Titanium.App.isAndroid )
				{
					aField.borderWidth = 1;
					aField.borderColor = '#2e2d2d';
				}
			}

			// Añadimos el mensaje de error al mensaje principal
			sMessageError += sMessage;
		}

		// Si tenemos un mensaje de error lo mostramos
		if( sMessageError != '' )
		{
			// Posicionamos el scroll al principio
			if( aParent.toString() == '[object TiUIScrollView]')
				aParent.scrollTo( 0, 0 );

			// Informamos de los errores
			Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_error' ), message:getLocatedString( 'message_error_form' ) + '\n' + sMessageError, buttonNames:['Aceptar'] }).show();
		}

		// Retornamos si el formulario se ha validado
		return sMessageError == '';
	};
}