Titanium.include( '/database.js' );
Titanium.include( '/functions/app.js' );

function Saves(sType)
{
	var self = this;

	this.saveFile = function(aRecord)
	{
		// Variables
		aRecords = [];
		bExists = false;

		// Obtenemos el archivo
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

		// Si existe el txt lo recorremos
		if( aFile.exists() )
		{
			// Obtenemos los registros
			var aRecords = eval( '(' + aFile.read().text + ')' );

			// Eliminamos
			aFile.deleteFile();
		}

		// Actualizamos el registro si existe
		for( var nCont = 0; nCont <= aRecords.length - 1; nCont++ )
		{
			if( aRecords[nCont]['id'] == aRecord['id'] )
			{
				aRecords[nCont] = aRecord;
				bExists = true;
			}
		}

		// Si el registro no existe lo añadimos
		if( bExists === false )
			aRecords.push( aRecord );

		// Creamos nuevo fichero
		aFile.write( JSON.stringify( aRecords ) );
	}

	this.favoritesSave = function(aRecord)
	{
		// Obtenemos el archivo
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

		// Si existe el archivo
		if( aFile.exists() )
		{
			// Obtenemos los registros
			var aRecords = eval( '(' + aFile.read().text + ')' );

			// Buscamos si el registro ya existe
			for( var nCont = 0; nCont <= aRecords.length - 1; nCont++ )
			{
				// Si el registro ya existe mostramos mensaje
				if( aRecords[nCont].id == aRecord.idproduct )
				{
					// Mensaje informativo
					showAlert( getLocatedString( 'message_favorites_exists' ) );

					return false;
				}
			}
		}

		// Salvamos el archivo
		this.saveFile({ id:aRecord.idproduct });

		// Informamos
		this.inform( getLocatedString( 'message_favorites_added' ), this.getBadge() );

		return true;
	}

	this.cartSave = function(aRecord)
	{
		// Variable de badge
		var nBadge = null;

		// Si no estamos logueados salvamos el carrito en local
		if( ! Titanium.App.User.isLogged() )
		{
			// Obtenemos el archivo
			var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

			// Si existe el archivo
			if( aFile.exists() )
			{
				// Obtenemos los registros
				var aRecords = eval( '(' + aFile.read().text + ')' );

				// Buscamos si el registro ya existe y le sumamos la cantidad
				for( var nCont = 0; nCont <= aRecords.length - 1; nCont++ )
					if( aRecords[nCont].id == aRecord.idproduct )
						aRecord.quantity = ( parseInt( aRecord.quantity ) + parseInt( aRecords[nCont].quantity ) ).toString();
			}

			// Salvamos el archivo
			this.saveFile({ id:aRecord.idproduct, quantity:aRecord.quantity });

			// Informamos
			self.inform( getLocatedString( 'message_cart_added' ), this.getBadge() );

			return true;
		}
		// Si estamos logueados añadimos el producto al carro de oscommerce
		else
		{
			// Insertamos en el carrito remoto
			query({ query:'insertProductIntoBasket', data:{ userid:Titanium.App.User.userid, productid:aRecord.idproduct, quantity:aRecord.quantity }, callback:function(aResult)
				{
					// Si obtenemos un resultado
					if( aResult != false )
					{
						// Informamos
						self.inform( 'Producto añadido a tu carrito.', aResult['cart'] );

						return true;
					}
					// Si hemos obtenido un error
					else
						return false;
				}
			});
		}
	}

	this.cartGetQuantity = function(nID)
	{
		// Obtenemos el archivo
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

		// Si existe el archivo
		if( aFile.exists() )
		{
			// Obtenemos los registros
			var aRecords = eval( '(' + aFile.read().text + ')' );

			// Buscamos el registro
			for( var nCont = 0; nCont <= aRecords.length - 1; nCont++ )
				if( aRecords[nCont].id == nID )
					return aRecords[nCont].quantity.toString();
		}

		return '0';
	}

	this.deleteRecord = function(aRecord)
	{
		// Si estamos en el carrito y logueados lo eliminamos también del carrito remoto
		if( sType == 'cart' && Titanium.App.User.isLogged() )
		{
			// Eliminamos del carrito
			query({ query:'deleteProductFromBasket', data:{ userid:Titanium.App.User.userid, productid:aRecord.id }, callback:function(aResult)
				{
					// Si obtenemos un resultado
					if( aResult != false )
					{
						// Informamos
						self.inform( getLocatedString( 'message_cart_deleted' ), aResult['cart'] );

						return true;
					}
					// Si hemos obtenido un error
					else
						return false;
				}
			});
		}
		// Si no estamos ni en el carrito ni logueados eliminamos localmente el registro
		else
		{
			Titanium.include( '/functions/array.js' );

			// Variables
			aRecords = [];

			// Obtenemos el archivo
			var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

			// Si existe el txt lo recorremos
			if( aFile.exists() )
			{
				// Obtenemos los registros
				var aRecords = eval( '(' + aFile.read().text + ')' );

				// Eliminamos
				aFile.deleteFile();
			}

			// Eliminamos el registro
			aRecords = arrayDeleteRecord( aRecords, aRecord, 'id' );

			// Creamos nuevo fichero
			aFile.write( JSON.stringify( aRecords ) );

			// Informamos
			this.inform( (sType == 'favoritos' ? getLocatedString( 'message_favorites_deleted' ) : getLocatedString( 'message_cart_deleted' )) + '.', this.getBadge() );

			// Retornamos los registros
			return aRecords;
		}
	}

	this.transfer = function()
	{
		// Forzamos a que el tipo sea carrito
		sType = 'cart';

		// Obtenemos el archivo
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, 'favorites.txt' );

		// Si existe el archivo
		if( aFile.exists() )
		{
			// Obtenemos los registros
			var aRecords = eval( '(' + aFile.read().text + ')' );

			// Si no estamos logueados
			if( ! Titanium.App.User.isLogged() )
			{
				// Recorremos los registros y los añadimos al carrito
				for( var nCont = 0; nCont <= aRecords.length - 1; nCont++ )
					this.saveFile({ id:aRecords[nCont].id, quantity:(parseInt( self.cartGetQuantity( aRecords[nCont].id ) ) + 1).toString() });

				// Vaciamos los favoritos
				// aFile.deleteFile();

				// Informamos
				this.inform( 'Transferidos tus favoritos al carrito.', this.getBadge() );
/*
				// Mostramos el badge en Android
				if( Titanium.Platform.osname == 'android' )
				{
					
				}
				// Mostramos el badge en iOS
				else
					Titanium.UI.currentTabGroup.tabs[1].badge = null;
*/
				return true;
			}
			// Si estamos logueados
			else
			{
				// Insertamos en el carrito remoto
				query({ query:'insertProductsIntoBasket', data:{ userid:Titanium.App.User.userid, products:aFile.read().text }, callback:function(aResult)
					{
						// Si obtenemos un resultado
						if( aResult != false )
						{
							// Vaciamos los favoritos
							// aFile.deleteFile();

							// Informamos
							self.inform( getLocatedString( 'message_transfered_to_cart' ), aResult['cart'] );
/*
							// Mostramos el badge en Android
							if( Titanium.Platform.osname == 'android' )
							{
								
							}
							// Mostramos el badge en iOS
							else
								Titanium.UI.currentTabGroup.tabs[1].badge = null;
*/
							return true;
						}
						// Si hemos obtenido un error
						else
							return false;
					}
				});
			}
		}
	}

	this.getValue = function(sField)
	{
		// Obtenemos el archivo
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

		// Si el fichero no existe devolvemos false		
		if( ! aFile.exists() )
			return false;

		// Obtenemos los registros
		var aRecords = eval( '(' + aFile.read().text + ')' );

		// Si obtenemos el campo lo retornamos
		if( aRecord[sField] !== undefined )
			return aRecord[sField];

		return false;
	}

	this.getBadge = function()
	{
		// Obtenemos el archivo
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

		// Variable de resultado
		var nBadge = 0;

		// Si existe el archivo
		if( aFile.exists() )
		{
			// Obtenemos los registros
			var aRecords = eval( '(' + aFile.read().text + ')' );

			// Recorremos los registros
			for( var nCont = 0; nCont <= aRecords.length - 1; nCont++ )
				nBadge = nBadge + (sType == 'cart' ? parseInt( aRecords[nCont].quantity ) : 1);
		}

		return (nBadge > 0 ? nBadge : null);
	}

	this.recordCount = function()
	{
		// Obtenemos el archivo
		var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

		// Si el fichero no existe devolvemos 0
		if( ! aFile.exists() )
			return 0;

		// Obtenemos los registros
		var aRecords = eval( '(' + aFile.read().text + ')' );

		// Retornamos la cantidad
		return aRecords.length;
	}

	this.deleteFile = function()
	{
		// Si estamos en el carrito y logueados lo eliminamos también del carrito remoto
		if( sType == 'cart' && Titanium.App.User.isLogged() )
		{
			// Eliminamos del carrito
			query({ query:'deleteBasket', data:{ userid:Titanium.App.User.userid }, callback:function(aResult)
				{
					// Si obtenemos un resultado
					if( aResult != false )
					{
						// Informamos
						self.inform( 'Se ha vaciado el ' + (sType == 'favorites' ? 'listado de favoritos' : 'carrito') + '.', null );

						return true;
					}
					// Si hemos obtenido un error
					else
						return false;
				}
			});
		}
		// Si no estamos ni en el carrito ni logueados lo eliminamos localmente el archivo
		else
		{
			// Obtenemos el archivo
			var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, sType + '.txt' );

			// Eliminamos el archivo si existe
			if( aFile.exists() )
				aFile.deleteFile();

			// Informamos
			this.inform( 'Se ha vaciado el ' + (sType == 'favorites' ? 'listado de favoritos' : 'carrito') + '.', null );

			return true;
		}
	}

	this.inform = function(sMessage, nBadge)
	{
		// Mensaje informativo
		showAlert( sMessage );

		// Si tenemos un badge lo añadimos
		if( nBadge !== false )
		{
			// Mostramos el badge en Android
			if( Titanium.Platform.osname == 'android' )
			{
				
			}
			// Mostramos el badge en iOS
			else
				Titanium.UI.currentTabGroup.tabs[(sType == 'favorites' ? 1 : 2)].badge = (nBadge > 0 ? nBadge : null);
		}

		// Hacemos que el dispositivo vibre
		Titanium.Media.vibrate();
	}
}