Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/functions/location.js' );

function topBar(aOptions)
{
	var self = this;

	// Propiedades
	var vTopBar = undefined;
	var sSearch = undefined;
	var wWindow = undefined;

	var tTable = undefined;
	var pPicker = undefined;
	var bEditing = false;

	this.show = function()
	{
		// Ventana
		this.wWindow = (aOptions.window ? aOptions.window : Titanium.UI.currentWindow);

		// Fondo blanco
		self.wWindow.backgroundColor = '#FFFFFF';

		// Evento que se lanza cuando damos foco a la ventana ** PRODUCE WARNING **
		self.wWindow.addEventListener( 'focus', function(e)
		{
			// Registramos la URL lanzada en Analytics
			Titanium.App.Analytics.trackPageview( '/' + Titanium.UI.currentWindow.url );
		});

		// Valores iniciales //

		// Cálculo de tamaños
		var nWidth = Titanium.Platform.displayCaps.platformWidth;
		var nHeight = Titanium.Platform.displayCaps.platformHeight;

		// Calculamos el ancho y alto según la densidad
		if( Titanium.Platform.osname == 'android' )
		{
			// Ancho y alto según densidad
			nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
		}

		// TopBar en Android
		//if( Titanium.App.isAndroid )
		if( true )
		{
			// Indicamos que mostramos topBar
			self.wWindow.navBarHidden = true;
			self.wWindow.titleControl = false;

			// Ponemos opaco el color del staturbar
			if( ! Titanium.App.isAndroid )
				self.wWindow.statusBarStyle = Titanium.UI.iPhone.StatusBar.OPAQUE_BLACK;

			// Orientación
			Titanium.UI.orientation = Titanium.UI.PORTRAIT;

			// Creamos el view contenedor
			this.vTopBar = Titanium.UI.createView({ width:nWidth, height:Titanium.App.topBarSize, top:10, left:0, backgroundColor:'transparent' });

			// Creamos el label de información
			var lTitle = Titanium.UI.createLabel({ text:(self.wWindow.title.length > 12 ? self.wWindow.title.substr( 0, 9 ) + '...' : self.wWindow.title ), textAlign:'center', wordWrap:true, left:0, right:0, font:{ fontSize:nWidth * 0.055, fontWeight:"bold" }, color:'#FFFFFF', backgroundColor:'transparent' });
			this.vTopBar.add( lTitle );

			// Mostramos el botón de volver
			if( self.wWindow.windowParent != undefined )
			{
				// Mostramos el backbutton
				var bBackButton = this.showBackButton();

				// Reposicionamos el titulo
				lTitle.left = bBackButton.left + bBackButton.width + (nWidth * 0.015625);
			}

			// Comprobamos si debemos mostrar el botón de búsqueda
			if( ( aOptions.hasOwnProperty( 'showSearchButton' ) && aOptions.showSearchButton == true ) || ! aOptions.hasOwnProperty( 'showSearchButton' ) )
			{
				var bSearch = this.showSearchButton();

				// Reposicionamos el título
				lTitle.right = bSearch.right + bSearch.width + (nWidth * 0.015625);
			}

			// Comprobamos si tenemos botón de editar
			if( aOptions.hasOwnProperty( 'editButton' ) && aOptions.editButton !== false && ! Titanium.App.isAndroid )
			{
				// Evento cuando hacemos click en el botón de Editar
				var editClick = function(e)
				{
					// Si tenemos datos a editar
					if( self.tTable != undefined )
					{
						// Ocultamos el picker
						if( self.pPicker != undefined )
							self.pPicker.animate( Titanium.UI.createAnimation({ bottom:-self.pPicker.height }) );

						// Marcamos como que editamos o no en la tabla de productos
						self.tTable.editing = ! self.tTable.editing;
						e.text = (self.tTable.editing ? 'OK' : 'Editar');
						self.bEditing = self.tTable.editing;
					}
				};

				// Mostramos el botón
				this.showTopButton( getLocatedString( 'text_edit' ), 'right', editClick );
			}		

			// Colocamos bien el label de título
			if( lTitle.left == 0 && lTitle.right != 0 )
				lTitle.left = lTitle.right;
			if( lTitle.right == 0 && lTitle.left != 0 )
				lTitle.right = lTitle.left;

			// Añadimos el topbar
			self.wWindow.add( this.vTopBar );
		}
/*
		// TopBar en iOS
		else
		{
			// Color blanco en el titulo
			//if( Ti.Platform.version >= 7 || Titanium.Platform.osname == 'ipad' )
			{
				// Cambiamos el label
				var lTitle = Titanium.UI.createLabel({ color:'#ffffff', height:18, width:210, top:10, text:self.wWindow.title, textAlign:'center', font:{fontFamily:'Trebuchet MS', fontSize:15, fontWeight:'bold'} });
				self.wWindow.setTitleControl( lTitle );
			}

			// Indicamos que mostramos topBar
			self.wWindow.navBarHidden = false;

			// Cambiamos la imagen del tab
			self.wWindow.barImage = getImage( 'navbar.png' );

			// Mostramos el botón de volver
			if( self.wWindow.windowParent != undefined )
				this.showBackButton();

			// Comprobamos si debemos mostrar el botón de búsqueda
			if( ( aOptions.hasOwnProperty( 'showSearchButton' ) && aOptions.showSearchButton == true ) || ! aOptions.hasOwnProperty( 'showSearchButton' ) )
				this.showSearchButton();

			// Comprobamos si tenemos botón de editar
			if( aOptions.hasOwnProperty( 'editButton' ) && aOptions.editButton !== false )
			{
				// Evento cuando hacemos click en el botón de Editar
				var editClick = function(e)
				{
					// Si tenemos datos a editar
					if( self.tTable != undefined )
					{
						// Ocultamos el picker
						if( self.pPicker != undefined )
							self.pPicker.animate( Titanium.UI.createAnimation({ bottom:-self.pPicker.height }) );

						// Marcamos como que editamos o no en la tabla de productos
						self.tTable.editing = ! self.tTable.editing;
						e.text = (self.tTable.editing ? 'OK' : 'Editar');
						self.bEditing = self.tTable.editing;
					}
				};

				// Mostramos el botón
				this.showTopButton( getLocatedString( 'text_edit' ), 'right', editClick );
			}		
		}
*/
	};

	this.setTable = function(tTable)
	{
		// Establecemos el valor de tTable
		this.tTable = tTable;
	};

	this.setPicker = function(pPicker)
	{
		// Establecemos el valor de pPicker
		this.pPicker = pPicker;
	};

	this.getEditing = function()
	{
		// Retornamos el valor editing
		return this.bEditing;
	};

	this.showBackButton = function()
	{
		// Cálculo de tamaños //

		var nWidth = Titanium.Platform.displayCaps.platformWidth;
		var nHeight = Titanium.Platform.displayCaps.platformHeight;

		// Tamaños para el iPad
		if( Titanium.Platform.osname == 'ipad' )
		{
			nWidth = 320;
			nHeight = 480;
		}

		// Calculamos el ancho y alto según la densidad
		if( Titanium.Platform.osname == 'android' )
		{
			// Ancho y alto según densidad
			nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
		}

		// Botón de volver //

		// Obtenemos el texto del botón volver
		var sText = (self.wWindow.windowParent.title != null ? (self.wWindow.windowParent.title.length > 10 ? self.wWindow.windowParent.title.substring( 0, 7 ) + '...' : self.wWindow.windowParent.title) : getLocatedString( 'button_back' ));

		// Creamos la vista contenedor
		var vBackButton = Titanium.UI.createView({ left:nWidth * 0.015625, width:'auto', height:nWidth * 0.09375, backgroundColor:'transparent' });

		// Si estamos en iOS
		if( ! Titanium.App.isAndroid )
		{
			// Creamos el label auxiliar para calcular el tamaño del botón
			var iAux = Titanium.UI.createLabel({ text:sText, font:{fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0375, fontWeight:'bold'}, textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, width:'auto', height:vBackButton.height });
			iAux = iAux.toImage();
			var nLabelWidth = iAux.width;
		}
		// Si estamos en Android
		else
			// El ancho es fijo a 100
			var nLabelWidth = wPer( 120 );

		// Flecha izquierda
		var iLeft = Titanium.UI.createImageView({ image:getImage( 'backbutton_left_off.png' ), left:0, top:0, width:nWidth * 0.0375, height:vBackButton.height });
		vBackButton.add( iLeft );
		// Centro
		var iCenter = Titanium.UI.createLabel({ text:sText, font:{fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0375, fontWeight:'bold'}, color:'#ddc559', textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, left:iLeft.width, top:0, width:nLabelWidth, height:vBackButton.height, backgroundImage:getImage( 'backbutton_center_off.png' ) });
		vBackButton.add( iCenter );
		// Borde derecho
		var iRight = Titanium.UI.createImageView({ image:getImage( 'backbutton_right_off.png' ), left:iCenter.left + iCenter.width, top:0, width:nWidth * 0.015625, height:vBackButton.height });
		vBackButton.add( iRight );

		// Establecemos el ancho del contenedor
		vBackButton.width = iLeft.width + iCenter.width + iRight.width;

		// Establecemos el botón izquierdo en Android
		//if( Titanium.App.isAndroid ) this.vTopBar.add( vBackButton );
		this.vTopBar.add( vBackButton );
		// Establecemos el botón izquierdo en iOS
		//else self.wWindow.setLeftNavButton( vBackButton );

		// Evento cuando pulsamos sobre el botón de volver
		iLeft.addEventListener( 'touchstart', function(e){ touch( 'on' ); } );
		iCenter.addEventListener( 'touchstart', function(e){ touch( 'on' ); } );
		iRight.addEventListener( 'touchstart', function(e){ touch( 'on' ); } );
		// Evento cuando soltamos el botón de volver
		iLeft.addEventListener( 'touchend', function(e){ touch( 'off' ); } );
		iCenter.addEventListener( 'touchend', function(e){ touch( 'off' ); } );
		iRight.addEventListener( 'touchend', function(e){ touch( 'off' ); } );
		// Evento cuando hacemos click en el botón de volver
		iLeft.addEventListener( 'singletap', function(e){ self.wWindow.close(); } );
		iCenter.addEventListener( 'singletap', function(e){ self.wWindow.close(); } );
		iRight.addEventListener( 'singletap', function(e){ self.wWindow.close(); } );

		// Función para cambiar las imágenes del botón
		function touch(sPos)
		{
			// Obtenemos las imágenes del botón
			sLeft = getImage( 'backbutton_left_' + sPos + '.png' );
			sCenter = getImage( 'backbutton_center_' + sPos + '.png' );
			sRight = getImage( 'backbutton_right_' + sPos + '.png' );

			// Cambiamos las imágenes
			iLeft.image = sLeft;
			iCenter.backgroundImage = sCenter;
			iCenter.color = (sPos == 'on' ? '#000000' : '#ddc559');
			iRight.image = sRight;
		}

		// Retornamos el backbutton
		return vBackButton;
	};

	this.showSearchButton = function()
	{
		// Cálculo de tamaños //

		var nWidth = Titanium.Platform.displayCaps.platformWidth;
		var nHeight = Titanium.Platform.displayCaps.platformHeight;

		// Tamaños para el iPad
		if( Titanium.Platform.osname == 'ipad' )
		{
			nWidth = 320;
			nHeight = 480;
		}

		// Calculamos el ancho y alto según la densidad
		if( Titanium.Platform.osname == 'android' )
		{
			// Ancho y alto según densidad
			nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
		}

		// Creamos el botón derecho
		var bSearch = Titanium.UI.createImageView({ image:getImage( 'search_off.png' ), right:nWidth * 0.015625, top:(Titanium.App.topBarSize / 2) - (wPer( 65 ) / 2), width:wPer( 135 ), height:wPer( 65 ) });
		// Establecemos el botón derecho en Android
		//if( Titanium.Platform.osname == 'android' ) this.vTopBar.add( bSearch );
		if( true ) this.vTopBar.add( bSearch );
		// Establecemos el botón derecho en iOS
		else self.wWindow.setRightNavButton( bSearch );

		// Evento que se lanza al clicar en el botón derecho
		bSearch.addEventListener('click', function(e)
		{
			// Si clicamos en la parte izquierda del botón mostramos el buscador
			if( e.x <= e.source.width / 2 )
			{
				/* Búsqueda */

				if( self.sSearch == undefined )
				{
					// Cálculo de tamaños
					var nWidth = Titanium.Platform.displayCaps.platformWidth;
					var nHeight = Titanium.Platform.displayCaps.platformHeight;

					// Calculamos el ancho y alto según la densidad
					if( Titanium.Platform.osname == 'android' )
					{
						// Ancho y alto según densidad
						nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
						nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
					}

					// Cambiamos la imagen del boton derecho
					bSearch.image = getImage( 'search_on_1.png' );

					// Creamos la caja de búsqueda de artículos
					self.sSearch = Titanium.UI.createSearchBar({ hintText:getLocatedString( 'message_search' ), barColor:'transparent', top:Titanium.App.top, width:nWidth, height:nHeight * 0.092, softKeyboardOnFocus:(Titanium.Platform.osname == 'android' ? Titanium.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS : false) });
					self.wWindow.add( self.sSearch );
					self.sSearch.focus();

					// Evento que se lanza cuando buscamos
					self.sSearch.addEventListener('return', function(e)
					{
						// Obtenemos el valor de la busqueda
						sResult = self.sSearch.value;

						// Cambiamos la imagen del boton derecho
						bSearch.image = getImage( 'search_off.png' );

						// Quitamos el buscador
						self.wWindow.remove( self.sSearch );
						self.sSearch = undefined;

						// Si estamos en Android forzamos la salida del teclado
						if( Titanium.Platform.osname == 'android' )
							Ti.UI.Android.hideSoftKeyboard();

						// Buscamos productos
						if( sResult != '' )
						{
							// Abrimos la ventana de productos
							var wProducts = Titanium.UI.createWindow({ type:'search', value:sResult, title:getLocatedString( 'text_search' ), backgroundColor:'#ffffff', url:'products.js', windowParent:self.wWindow });

							// Abrimos la ventana
							openWindowInTab( wProducts );
						}
					});
				}
				else
				{
					// Cambiamos la imagen del boton derecho
					bSearch.image = getImage( 'search_off.png' );

					// Quitamos el buscador
					self.wWindow.remove( self.sSearch );
					self.sSearch = undefined;

					// Si estamos en Android forzamos la salida del teclado
					if( Titanium.Platform.osname == 'android' )
						Ti.UI.Android.hideSoftKeyboard();
				}
			}
			// Si clicamos en la parte derecha del botón vamos al inicio
			else
			{
				// Cambiamos la imagen del boton derecho
				bSearch.image = getImage( 'search_on_2.png' );

				// Obtenemos la ventana actual
				var wAux = self.wWindow;

				// Mientras la ventana tenga padre vamos cerrando
				while( wAux.windowParent != undefined )
				{
					// Cerramos la ventana y si es la última por cerrar lo hacemos con animación
					wAux.close({ animated:wAux.windowParent.windowParent == undefined });
					// La ventana padre será la actual
					wAux = wAux.windowParent;
				}
			}
		});

		// Retornamos el botón de buscar
		return bSearch;
	};

	this.showTopButton = function(sText, sPosition, fClick)
	{
		// Cálculo de tamaños //

		var nWidth = Titanium.Platform.displayCaps.platformWidth;
		var nHeight = Titanium.Platform.displayCaps.platformHeight;

		// Tamaños para el iPad
		if( Titanium.Platform.osname == 'ipad' )
		{
			nWidth = 320;
			nHeight = 480;
		}

		// Calculamos el ancho y alto según la densidad
		if( Titanium.Platform.osname == 'android' )
		{
			// Ancho y alto según densidad
			nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
		}

		// Botón //

		// Obtenemos el texto del botón
		sText = (sText.length > 10 ? sText.substring( 0, 7 ) + '...' : sText);

		// Obtenemos las opciones
		aOptions.width = 'auto';
		aOptions.height = nWidth * 0.09375;
		aOptions.backgroundColor = 'transparent';

		// Creamos la vista contenedor
		var vButton = Titanium.UI.createView( aOptions );

		// Si estamos en iOS
		if( ! Titanium.App.isAndroid )
		{
			// Creamos el label auxiliar para calcular el tamaño del botón
			var iAux = Titanium.UI.createLabel({ text:sText, font:{fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0375, fontWeight:'bold'}, textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, width:'auto', height:vButton.height });
			iAux = iAux.toImage();
			var nLabelWidth = iAux.width;
		}
		// Si estamos en Android
		else
			// El ancho es fijo a 100
			var nLabelWidth = wPer( 100 );

		// Flecha izquierda
		var iLeft = Titanium.UI.createImageView({ image:getImage( 'button_left_off.png' ), left:0, top:0, width:nWidth * 0.015625, height:vButton.height });
		vButton.add( iLeft );
		// Centro
		var iCenter = Titanium.UI.createLabel({ text:sText, font:{fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0375, fontWeight:'bold'}, color:'#ddc559', textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, left:iLeft.width, top:0, width:nLabelWidth, height:vButton.height, backgroundImage:getImage( 'button_center_off.png' ) });
		vButton.add( iCenter );
		// Borde derecho
		var iRight = Titanium.UI.createImageView({ image:getImage( 'button_right_off.png' ), left:iCenter.left + iCenter.width, top:0, width:nWidth * 0.015625, height:vButton.height });
		vButton.add( iRight );

		// Establecemos el ancho del contenedor
		vButton.width = iLeft.width + iCenter.width + iRight.width;

		// Establecemos el botón en Android
		//if( Titanium.App.isAndroid )
		if( true )
		{
			if( sPosition == 'left' ) vButton.left = nWidth * 0.010416667;
			else if( sPosition == 'right' ) vButton.right = nWidth * 0.010416667;
			this.vTopBar.add( vButton );
		}
		// Establecemos el botón en iOS
		else
		{
			if( sPosition == 'left' ) self.wWindow.setLeftNavButton( vButton );
			else if( sPosition == 'right' ) self.wWindow.setRightNavButton( vButton );
			else self.wWindow.add( vButton );
		}

		// Evento cuando pulsamos sobre el botón de volver
		iLeft.addEventListener( 'touchstart', function(e){ touch( 'on' ); } );
		iCenter.addEventListener( 'touchstart', function(e){ touch( 'on' ); } );
		iRight.addEventListener( 'touchstart', function(e){ touch( 'on' ); } );
		// Evento cuando soltamos el botón de volver
		iLeft.addEventListener( 'touchend', function(e){ touch( 'off' ); } );
		iCenter.addEventListener( 'touchend', function(e){ touch( 'off' ); } );
		iRight.addEventListener( 'touchend', function(e){ touch( 'off' ); } );
		// Evento cuando hacemos click en el botón de volver
		iLeft.addEventListener( 'singletap', function(e){ fClick( iCenter ); } );
		iCenter.addEventListener( 'singletap', function(e){ fClick( iCenter ); } );
		iRight.addEventListener( 'singletap', function(e){ fClick( iCenter ); } );

		// Función para cambiar las imágenes del botón
		function touch(sPos)
		{
			// Obtenemos las imágenes del botón
			sLeft = getImage( 'button_left_' + sPos + '.png' );
			sCenter = getImage( 'button_center_' + sPos + '.png' );
			sRight = getImage( 'button_right_' + sPos + '.png' );

			// Cambiamos las imágenes
			iLeft.image = sLeft;
			iCenter.backgroundImage = sCenter;
			iCenter.color = (sPos == 'on' ? '#000000' : '#ddc559');
			iRight.image = sRight;
		}

		// Retornamos el backbutton
		return vButton;
	};
}

function openWindow(wWindow)
{
	// Ocultamos la barra de título
	wWindow.navBarHidden = true;

	// Abrimos la ventana en el tab
	if( ! Titanium.App.isAndroid )
		Titanium.UI.currentTab.open( wWindow );
	// Abrimos la ventana
	else
		wWindow.open();
}

function openWindowInTab(wWindow)
{
	// Ocultamos la barra de título
	wWindow.navBarHidden = true;

	// Abrimos la ventana en el tab
	if( ! Titanium.App.isAndroid )
		Titanium.UI.currentTab.open( wWindow );
	// Abrimos la ventana
	else
		wWindow.open();
}