Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

/* Cálculo de tamaños */

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Label principal
var lCustomerService = Titanium.UI.createLabel({ text:'ATENCIÓN AL CLIENTE', font:{ fontSize:wPer( 30 ), fontWeight:'bold' }, color:'#ddc559', textAlign:'center', top:Titanium.App.top + wPer( 15 ), left:0, right:0, backgroundColor:'transparent' });
Titanium.UI.currentWindow.add( lCustomerService );

// Label email
var lEmail = Titanium.UI.createLabel({ text:'info@canariasmakeup.com', font:{ fontSize:wPer( 30 ), fontWeight:'bold' }, color:'#ddc559', textAlign:'center', top:Titanium.App.top + wPer( 65 ), left:wPer( 94 ), right:wPer( 94 ), height:wPer( 80 ), backgroundColor:'transparent', borderWidth:1, borderColor:'#ddc559', borderRadius:10 });
Titanium.UI.currentWindow.add( lEmail );

// Evento cuando pulsamos en un elemento
lEmail.addEventListener('touchstart', function(e)
{
	// Cambiamos los colores
	this.color = '#FFFFFF';
	this.backgroundColor = '#ddc559';
});

// Evento cuando soltamos un elemento
lEmail.addEventListener('touchend', function(e)
{
	// Cambiamos los colores
	this.color = '#ddc559';
	this.backgroundColor = 'transparent';
});

// Evento cuando soltamos un elemento
lEmail.addEventListener('touchcancel', function(e)
{
	// Cambiamos los colores
	this.color = '#ddc559';
	this.backgroundColor = 'transparent';
});

// Evento cuando hacemos click en un elemento
lEmail.addEventListener('click', function(e)
{
	var eDialog = Titanium.UI.createEmailDialog();
	eDialog.toRecipients = ['info@canariasmakeup.com'];
	eDialog.open();
});

// Linea separatoria
var lLine = Titanium.UI.createView({ top:lEmail.top + lEmail.height + wPer( 25 ), left:0, right:0, height:1, backgroundColor:'#ddc559' });
Titanium.UI.currentWindow.add( lLine );

// Añadimos los botones de contacto
var aAux = null;
aAux = showContactButton( 'contact_facebook', 'facebook.com/canariasmakeup', 'fb://profile/250532465072416', lLine.top + lLine.height + wPer( 25 ) );
aAux = showContactButton( 'contact_twitter', '@canariasmakeup', 'https://www.twitter.com/Canariasmakeup', aAux.top + aAux.height + wPer( 20 ) );
aAux = showContactButton( 'contact_instagram', '@canariasmakeup', 'http://www.instagram.com/canariasmakeup/', aAux.top + aAux.height + wPer( 20 ) );
aAux = showContactButton( 'contact_youtube', 'youtube.com/user/canariasmakeup', 'http://www.youtube.com/user/canariasmakeup/', aAux.top + aAux.height + wPer( 20 ) );

function showContactButton(sImage, sText, sLink, nTop)
{
	// Contenedor
	var aContent = Titanium.UI.createView({ left:wPer( 40 ), right:wPer( 40 ), top:nTop, height:wPer( 112 ), backgroundColor:'transparent' });
	Titanium.UI.currentWindow.add( aContent );
	// Imagen izquierda
	var iImage = Titanium.UI.createImageView({ image:getImage( sImage + '_off.png' ), left:0, top:0, bottom:0 });
	aContent.add( iImage );
	// Titulo
	var lTitle = Titanium.UI.createLabel({ text:sText, font:{ fontSize:wPer( 30 ), fontWeight:'bold', fontFamily:'Helvetica Neue' }, color:'#ddc559', textAlign:'left', left:wPer( 212 ) + wPer( 15 ), right:0, top:aContent.height / 3 });
	aContent.add( lTitle );
	// Zona clicable
	var lClick = Titanium.UI.createView({ left:0, right:0, top:0, bottom:0, backgroundColor:'transparent', row_image:iImage, row_title:lTitle, link:sLink });
	aContent.add( lClick );

	// Evento cuando pulsamos en un elemento
	lClick.addEventListener('touchstart', function(e)
	{
		// Cambiamos los colores
		this.row_image.image = this.row_image.image.replace( '_off', '_on' );
		this.row_title.color = '#FFFFFF';
	});

	// Evento cuando soltamos un elemento
	lClick.addEventListener('touchend', function(e)
	{
		// Cambiamos los colores
		this.row_image.image = this.row_image.image.replace( '_on', '_off' );
		this.row_title.color = '#ddc559';
	});

	// Evento cuando soltamos un elemento
	lClick.addEventListener('touchcancel', function(e)
	{
		// Cambiamos los colores
		this.row_image.image = this.row_image.image.replace( '_on', '_off' );
		this.row_title.color = '#ddc559';
	});

	// Evento cuando hacemos click en un elemento
	lClick.addEventListener('click', function(e)
	{
		// Ejecutamos la URL
		Titanium.Platform.openURL( this.link );
	});

	return aContent;
}