// Función para obtener un precio con un formato válido aplicandole una tasa
function getPriceFormatted(fPrice, fTax)
{
	// Si obtenemos false
	if( fPrice === false )
		return false;

	// Convertimos al tipo float
	fPrice = parseFloat( fPrice );
	// Le aplicamos el impuesto
	fPrice = ( fPrice * ( fTax / 100 ) ) + fPrice;
	// Convertimos a tipo moneda
	fPrice = String.formatDecimal( fPrice, 'es-ES', "#,###.##" );

	// Si no tiene 00 al final lo añadimos
	aAux = fPrice.split( ',' );
	fPrice = fPrice + (aAux.length > 1 ? (aAux[1].length == 1 ? '0' : '') : ',00');

	return fPrice;
}

function showPrice(aOptions)
{
	/* Cálculo de tamaños */

	var nWidth = Titanium.Platform.displayCaps.platformWidth;
	var nHeight = Titanium.Platform.displayCaps.platformHeight;

	/* Cálculo de precio */

	// Separamos la parte entera de la decimal del precio
	aAux = aOptions.price.split( ',' );

	// Obtenemos la parte entera
	nEntire = aAux[0];
	// Obtenemos la parte decimal
	nDecimal = ',' + aAux[1] + ' €';

	// Creamos el contenedor
	var aContent = Titanium.UI.createView({ left:aOptions.left, top:aOptions.top, width:aOptions.width, height:aOptions.height, layout:'horizontal', backgroundColor:'transparent' });

	// Label de parte entera
	lEntire = Titanium.UI.createLabel({ text:nEntire, font:{ fontName:'Helvetica Neue', fontSize:aOptions.fontSize, fontWeight:'bold' }, color:(aOptions.hasOwnProperty( 'color' ) ? aOptions.color : Titanium.App.price_color), left:0, top:0, width:'auto', height:'auto' });
	aContent.add( lEntire );

	// Label de la parte decimal
	lDecimal = Titanium.UI.createLabel({ text:nDecimal, font:{ fontName:'Helvetica Neue', fontSize:aOptions.fontSize / 1.5, fontWeight:'bold' }, color:(aOptions.hasOwnProperty( 'color' ) ? aOptions.color : Titanium.App.price_color), left:0, top:(aOptions.fontSize - (aOptions.fontSize / 1.5)), width:'auto', height:'auto' });
	aContent.add( lDecimal );

	// Mostramos el precio en oferta
	if( aOptions.offer !== false )
	{
		// Añadimos espacios
		lDecimal.text = lDecimal.text + '  ';

		// Contenedor para el precio en oferta
		var vOffer = Titanium.UI.createView({ left:0, width:nWidth * 0.25, backgroundColor:'#000000', top:(aOptions.fontSize - (aOptions.fontSize / 2)), height:'auto', backgroundColor:'transparent' });
		aContent.add( vOffer );

		// Mostramos la oferta
		var lPriceOffer = Titanium.UI.createLabel({ text:aOptions.offer + '€', font:{ fontSize:aOptions.fontSize / 2, fontWeight:'normal' }, color:'#bebebe', left:0, top:0, width:'auto', height:'auto' });
		vOffer.add( lPriceOffer );

		// Convertimos a imagen el texto para sacar sus dimensiones
		if( ! Titanium.App.isAndroid )
		{
			var aAux = lPriceOffer.toImage();
			nStrikeWidth = aAux.width;
			nStrikeHeight = aAux.height;
		}
		else
		{
			nStrikeWidth = lPriceOffer.width;
			nStrikeHeight = lPriceOffer.height;
		}

		// Añadimos la linea para tachar el precio
		var vStrike = Titanium.UI.createView({ left:0, width:nStrikeWidth, top:nStrikeHeight / 2, height:1, backgroundColor:lPriceOffer.color });
		vOffer.add( vStrike );
	}

	// Añadimos al contenedor el label decimal y el label entero
	aContent.entire = lEntire;
	aContent.decimal = lDecimal;

	return aContent;
}