/**
 * Función que devuelve un texto en un idioma 
 *
 * Parámetros:
 * 	string sName
 *
 */
function getLocatedString(sName, aParams)
{
	// Variable traducida
	var sLocated = '';

	// Obtenemos el fichero de idiomas
	var aFile = Ti.Filesystem.getFile( Ti.Filesystem.resourcesDirectory, 'i18n/' + Titanium.App.language + '/strings.xml' );
	var aXML = aFile.read().text;

	// Parseamos el XML
	var aXML = Ti.XML.parseString( aXML );

	// Obtenemos las cadenas
	var aStrings = aXML.documentElement.getElementsByTagName( 'string' );

	// Recorremos las cadenas y buscamos el texto
	for( var nCont = 0; nCont < aStrings.length ; nCont++ )
	{
		// Si encontramos la cadena la retornamos
	    if( aStrings.item( nCont ).getAttributeNode( 'name' ).value == sName )
	    {
	    	// Obtenemos la cadena
	    	sLocated = aStrings.item( nCont ).textContent;

			// Si tenemos parámetros los reemplazamos
			if( aParams != undefined )
				for( var nCont2 = 1; nCont2 <= aParams.length; nCont2++ )
					sLocated = sLocated.replace( '%' + nCont2.toString(), aParams[nCont2 - 1] );

			// Retornamos la cadena traducida
			return sLocated;
	    }
	}

	return false;
}

/**
 * Función que aumenta el tamaño de los textos pasados como parámetros
 * 
 * Parámetros:
 * 	aTexts array
 * 	aSizes array
 * 
 */
function setTextSize(aTexts, aSizes)
{
	// Recorremos los textos y aumentamos sus tamaños
	for( var nCont = 0; nCont < aTexts.length; nCont++ )
	{
		// Buscamos la coincidencia de tamaño de fuente
		for( var nCont2 = 0; nCont2 < aSizes.length; nCont2++ )
			if( aTexts[nCont].font.fontSize == aSizes[nCont2] )
				break;

		// Establecemos el tamaño de la fuente
		aTexts[nCont].setFont({ fontName:aTexts[nCont].font.fontName, fontSize:aSizes[(nCont2 + 1 >= aSizes.length ? 0 : nCont2 + 1)], fontWeight:aTexts[nCont].font.fontWeight });
	}
}