function pagingcontrol(aOptions)
{
	/* Cálculo de tamaños */

	var nWidth = Titanium.Platform.displayCaps.platformWidth;
	var nHeight = Titanium.Platform.displayCaps.platformHeight;

	// Calculamos el ancho y alto según la densidad
	if( Titanium.Platform.osname == 'android' )
	{
		// Ancho y alto según densidad
		nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
		nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	}

	var nDotSize = 6;
	var nDotSpace = nWidth * 0.025;

	/* Pintamos el pagingcontrol */

	// Creamos el contenedor
	var aContent = Titanium.UI.createView({ left:0, top:aOptions.top, width:nWidth, height:aOptions.height, backgroundColor:'transparent' });

	// Inicializamos
	var nLeft = (aContent.width / 2) - ((aOptions.view.views.length / 2) * nDotSize) - (((aOptions.view.views.length - 1) / 2) * nDotSpace);
	var aDots = [];

	// Pintamos los puntos
	for( var nCont = 0; nCont < aOptions.view.views.length; nCont++ )
	{
		// Creamos el punto
		var aDot = Titanium.UI.createImageView({ width:nDotSize, height:nDotSize, left:nLeft, top:(aContent.height / 2) - (nDotSize / 2), borderRadius:nDotSize / 2, backgroundColor:aOptions.unselectedColor });
		aContent.add( aDot );

		// Añadimos el punto al array
		aDots[nCont] = { dot:aDot, selected:false };

		// Si el dot pertenece a la página actual
		if( nCont == aOptions.view.currentPage )
		{
			aDots[nCont].dot.backgroundColor = aOptions.selectedColor;
			aDots[nCont].selected = true;
		}

		// Aumentamos la posición left
		nLeft += nDotSize + nDotSpace;
	}

	// Evento cuando cambiamos el elemento de la galeria
	aOptions.view.addEventListener( 'scroll', function(e)
	{
		// Desmarcamos el dot anterior
		for( var nCont = 0; nCont < aDots.length; nCont++ )
		{
			if( aDots[nCont].selected )
			{
				aDots[nCont].dot.backgroundColor = aOptions.unselectedColor;
				aDots[nCont].selected = false;
				break;
			}
		}

		// Cambiamos de color el dot seleccionado
		aDots[aOptions.view.currentPage].dot.backgroundColor = aOptions.selectedColor;
		aDots[aOptions.view.currentPage].selected = true;
	});

	// Retornamos el contenedor
	return aContent;
}