function shareFacebook(aParams)
{
	// Si está indicado que muestre un mensaje de diálogo
	if( aParams.dialog && aParams.dialog == true )
	{
		// Mensaje de diálogo
		var dDialog = Titanium.UI.createOptionDialog(
		{
			title: '¿Deseas compartir el contenido en Facebook?',
			options: ['Si', 'Cancelar'],
			destructive: 1
		});
		dDialog.show();
	
		// Evento que se lanza cuando se clica sobre alguna de las opciones del diálogo
		dDialog.addEventListener('click', function(e)
		{
			// Si clicamos en SI compartimos el contenido
			if( e.index == 0 )
				share();
		});
	}
	// Si no está indicado que muestre un mensaje de diálogo, compartirmos
	else
		share();

	function share()
	{
		// Incluimos la clase Facebook
		var aFacebook = require( 'facebook' );

		// Parámetros de Facebook
		aFacebook.appid = Titanium.App.facebook;
		aFacebook.permissions = ['publish_stream'];
		aFacebook.forceDialogAuth = false;
		aFacebook.authorize();

		// Posteamos la información del puesto
		aFacebook.requestWithGraphPath( 'me/feed', { message: aParams.message }, 'POST', function(e)
		{
			// Si se ha compartido correctamente
			if( e.success )
			    Titanium.UI.createAlertDialog({ title:'¡Compartido!', message:'Se ha compartido el contenido en Facebook.', buttonNames:['Aceptar'] }).show();
			// Si ha habido un error
			else
			{
				// Si tenemos un error
				if( e.error )
			        Titanium.UI.createAlertDialog({ title:'¡Error!', message:'Se ha producido el siguiente error: ' + e.error, buttonNames:['Aceptar'] }).show();
			    // Si tenemos un error desconocido
			    else
			        Titanium.UI.createAlertDialog({ title:'¡Error!', message:'Se ha producido un error desconocido.', buttonNames:['Aceptar'] }).show();
		    }
		});
	}
}

function shareTwitter(aParams)
{
	// Si está indicado que muestre un mensaje de diálogo
	if( aParams.dialog && aParams.dialog == true )
	{
		// Mensaje de diálogo
		var dDialog = Titanium.UI.createOptionDialog(
		{
			title: '¿Deseas compartir el contenido en Twitter?',
			options: ['Si', 'Cancelar'],
			destructive: 1
		});
		dDialog.show();

		// Evento que se lanza cuando se clica sobre alguna de las opciones del diálogo
		dDialog.addEventListener('click', function(e)
		{
			// Si clicamos en SI compartimos el contenido
			if( e.index == 0 )
				share();
		});
	}
	// Si no está indicado que muestre un mensaje de diálogo, compartirmos
	else
		share();

	function share()
	{
		// Creamos la ventana
		var wTwitter = Titanium.UI.createWindow(
		{
			title: 'Compartir en Twitter',
			backgroundColor:'#000000',
			navBarHidden: false,
			windowParent:Titanium.UI.currentWindow
		});

		// Mostramos el TopBar
		var aTopBar = new topBar(
		{
			window: wTwitter,
			showSearchButton: false,
		});
		aTopBar.show();

		wTwitter.backgroundColor = '#000000';

		// Navegador web
		var wWeb = Titanium.UI.createWebView(
		{
			url: 'https://twitter.com/intent/tweet?text=' + aParams.message,
			left: 0,
			right: 0,
			top: Titanium.App.top,
			bottom: Titanium.App.bottom,
			scalesPageToFit: true
		});
		wTwitter.add( wWeb );

		// Evento cuando carga la web
		wWeb.addEventListener('load', function(e)
		{
			// Si se ha compartido
			if( e.source.url.match( /(complete)/i ) )
			{
				// Mensaje de información
				Titanium.UI.createAlertDialog({ title:'¡Compartido!', message:'Se ha compartido el contenido en Twitter.', buttonNames:['Aceptar'] }).show();

				// Cerramos la ventana
				wTwitter.close();
			}
		});

		// Abrimos la ventana
		wTwitter.open();
	}
}

function shareEmail(aParams)
{
	// Si está indicado que muestre un mensaje de diálogo
	if( aParams.dialog && aParams.dialog == true )
	{
		// Mensaje de diálogo
		var dDialog = Titanium.UI.createOptionDialog(
		{
			title: '¿Deseas compartir el contenido por email?',
			options: ['Si', 'Cancelar'],
			destructive: 1
		});
		dDialog.show();

		// Evento que se lanza cuando se clica sobre alguna de las opciones del diálogo
		dDialog.addEventListener('click', function(e)
		{
			// Si clicamos en SI compartimos el contenido
			if( e.index == 0 )
				share();
		});
	}
	// Si no está indicado que muestre un mensaje de diálogo, compartirmos
	else
		share();

	function share()
	{
		var eDialog = Titanium.UI.createEmailDialog(
		{
			subject: 'Quiero compartir contigo algo...',
			messageBody: aParams.message
		});
		eDialog.open();
	}
}