Titanium.include( 'database.js' );
Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/functions/pagingcontrol.js' );
Titanium.include( '/classes/topbar.class.js' );

// Mostramos la barra de estado
//if( ! Titanium.App.isAndroid )
	//Titanium.UI.iPhone.showStatusBar();

// Ocultamos la barra de navegación
if( Titanium.App.isAndroid )
{
	Titanium.UI.currentWindow.navBarHidden = true;
	Titanium.UI.currentWindow.titleControl = false;
}

// Orientación Portrait
Titanium.UI.currentWindow.orientationModes = [ Ti.UI.PORTRAIT ];

// Fondo blanco
Titanium.UI.currentWindow.backgroundColor = '#FFFFFF';

// Hacemos una consulta para obtener las secciones principales
query({ query:'getSectionsAndSlider', data:{ language:Titanium.App.idlanguage }, callback:function(aResult)
	{
		// Si obtenemos un resultado correcto
		if( aResult !== false )
		{
			// Cálculo de tamaños //

			var nWidth = Titanium.Platform.displayCaps.platformWidth;
			var nHeight = Titanium.Platform.displayCaps.platformHeight;

			// Si la orientación es LANDSCAPE
			if( Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_RIGHT || Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_LEFT )
			{
				var nWidth = Ti.Platform.displayCaps.platformHeight;
				var nHeight = Ti.Platform.displayCaps.platformWidth;
			}

			// Calculamos el ancho y alto según la densidad
			if( Titanium.Platform.osname == 'android' )
			{
				// Ancho y alto según densidad
				nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
				nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			}

			// Home //

			// Array de datos para las secciones
			var aSections = [];
			// Array de imágenes para el slider
			var aImages = [];
			// Contador para el slider
			var nCont2 = 0;

			// Mostramos el logo
			var aLogo = Titanium.UI.createImageView({ image:getImage( 'logo.png' ) });
			css( aLogo, 'home_logo' );
			Titanium.UI.currentWindow.add( aLogo );

			// Recorremos el resultado y lo añadimos a la tabla
			for( var nCont = 0; nCont < aResult.length; nCont++ )
			{
				// Si es una imagen del slider
				if( aResult[nCont].parent == 'slider' )
				{
					// Creamos la imagen y la añadimos al array de la galería
					var aImage = Titanium.UI.createImageView({ image:encodeURI( Titanium.App.images.replace( 'productos', 'banners' ) + 'imagenes/' + aResult[nCont].image ), name:aResult[nCont].name, type:aResult[nCont].type, value:aResult[nCont].value, backgroundColor:'transparent', hires:true });
					aImages[nCont2] = aImage;

					// Evento cuando hacemos click en una imágen
					aImage.addEventListener('singletap', function(e)
					{
						// Según la imágen que cliquemos se abrirá una ventana u otra
						switch( e.source.type )
						{
							// Url
							case 'url': var wWindow = Titanium.UI.createWindow({ link:e.source.value, backgroundColor:'#ffffff', url:'web.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
							// Producto
							case 'product': var wWindow = Titanium.UI.createWindow({ id:e.source.value, title:e.source.name, backgroundColor:'#ffffff', url:'productdetail.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
							// Categoría destacada
							case 'category': var wWindow = Titanium.UI.createWindow({ type:'products', id:e.source.value, title:e.source.name, backgroundColor:'#ffffff', url:'products.js', backgroundColor:'#ffffff', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
							// Búsqueda
							case 'search': var wWindow = Titanium.UI.createWindow({ type:'search', value:e.source.value, title:'Búsqueda', backgroundColor:'#ffffff', url:'products.js', backgroundColor:'#ffffff', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
						}

						// Si estamos en iOS mostramos el topBar
						if( Titanium.Platform.osname != 'android' )
							wWindow.navBarHidden = false;
						wWindow.tabBarHidden = false;
						// Abrimos la ventana
						openWindowInTab( wWindow );
					});

					nCont2++;
				}
				// Si es una sección principal
				else if( aResult[nCont].parent == 'section' )
				{
					// Obtenemos la imágen
					sImage = getImage( aResult[nCont].type + '_off.png' );
					sImage = (sImage == '' ? aResult[nCont].image : sImage);

					// Creamos la fila
					if( aSections.length == 0 )
					{
						var aRowSpace = Titanium.UI.createTableViewRow({ type:'none', className:'sections_none', backgroundColor:'#ddc559', hasChild:false });
						css( aRowSpace, 'home_table_row_space' );
						aSections.push( aRowSpace );
					}

					// Creamos la fila
					var aRow = Titanium.UI.createTableViewRow({ type:aResult[nCont].type, name:aResult[nCont].name, value:aResult[nCont].value, className:'sections', backgroundImage:getImage( 'row_off.png' ), backgroundSelectedImage:getImage( 'row_on.png' ), hasChild:false });
					css( aRow, 'home_table_row' );

					// Creamos la imagen izquierda
					var iImage =  Titanium.UI.createImageView({ image:sImage, width:nWidth * 0.0875, height:nWidth * 0.0875, left:wPer( 85 ), backgroundColor:'transparent', hires:true });
					aRow.add( iImage );
					aRow.row_left_image = iImage;
					// Creamos el label del titulo
					var lTitle = Titanium.UI.createLabel({ text:aResult[nCont].name, minimumFontSize:2, font:{ fontSize:nWidth * 0.05, fontWeight:'bold', fontFamily:'Helvetica Neue' }, color:'#ddc559', textAlign:'left', left:iImage.left + iImage.width + ( iImage.left / 2 ), right:iImage.left, height:aRow.height });
					aRow.add( lTitle );
					aRow.row_title = lTitle;
					// Creamos la flecha derecha
					var iArrow = Titanium.UI.createImageView({ image:getImage( 'row_arrow_off.png' ), right:wPer( 30 ), width:wPer( 16 ), height:wPer( 25 ) });
					aRow.add( iArrow );
					aRow.row_arrow = iArrow;

					// Creamos la fila con espacio
					var aRowSpace = Titanium.UI.createTableViewRow({ type:'none', className:'sections_none', backgroundColor:'#ddc559', hasChild:false });
					css( aRowSpace, 'home_table_row_space' );

					// Añadimos la fila a los datos
					aSections.push( aRow );
					aSections.push( aRowSpace );

					// Si es del tipo novedades guardamos la cantidad de novedades a mostrar
					if( aResult[nCont].type == 'newness' )
						Titanium.App.newness_quantity = aResult[nCont].value;
					// Si es del tipo ofertas guardamos la cantidad de ofertas a mostrar
					if( aResult[nCont].type == 'offers' )
						Titanium.App.offers_quantity = aResult[nCont].value;
				}
			}

			// Slider //

			// Creamos el slider
			var sGallery = Titanium.UI.createScrollableView({ views:aImages, showPagingControl:false, pagingControlHeight:wPer( 10 ), pagingControlColor:'transparent', backgroundColor:'transparent', left:0, right:0, top: aLogo.top + aLogo.height + wPer( 10 ) });
			css( sGallery, 'home_gallery' );
			// Añadimos el rodillo de imágenes
			Titanium.UI.currentWindow.add( sGallery );

			// Animación para cambiar la imagen del rodillo
			function loadingAnimation()
			{
				// Hacemos scroll a la siguiente imagen, y si llegamos a la última empezamos desde la primera
				sGallery.scrollToView( (sGallery.currentPage < ( aImages.length - 1 ) ? sGallery.currentPage + 1 : 0) );
			}

			// Establecemos el intervalo de la animación y la lanzamos
			setInterval( loadingAnimation, 4000 );

			// Pagingcontrol
			var aPagingControl = pagingcontrol({ view:sGallery, top:sGallery.top + sGallery.height, height:wPer( 38 ), selectedColor:'#ddc559', unselectedColor:'#ffffff' });
			Titanium.UI.currentWindow.add( aPagingControl );

			// Tabla de secciones principales //

			// Creamos la tabla para mostrar las secciones principales
			var tTable = Titanium.UI.createTableView({ separatorStyle:0, backgroundColor:'transparent', top: sGallery.top + sGallery.height + wPer( 38 ) });
			css( tTable, 'home_table' );
			// Añadimos los datos a la tabla
			tTable.setData( aSections );
			// Añadimos la tabla
			Titanium.UI.currentWindow.add( tTable );

			// Evento cuando pulsamos en un elemento de la lista
			tTable.addEventListener('touchstart', function(e)
			{
				// Cambiamos los colores
				if( ! Titanium.App.isAndroid )
				{
					e.rowData.row_left_image.image = getImage( e.rowData.type + '_on.png' );
					e.rowData.row_title.color = '#000000';
					e.rowData.row_arrow.image = getImage( 'row_arrow_on.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchend', function(e)
			{
				// Cambiamos los colores
				if( ! Titanium.App.isAndroid )
				{
					e.rowData.row_left_image.image = getImage( e.rowData.type + '_off.png' );
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchcancel', function(e)
			{
				// Cambiamos los colores
				if( ! Titanium.App.isAndroid )
				{
					e.rowData.row_left_image.image = getImage( e.rowData.type + '_off.png' );
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando hacemos click en un elemento de la lista
			tTable.addEventListener('click', function(e)
			{
				// Según la sección que cliquemos se abrirá una ventana u otra
				switch( e.rowData.type )
				{
					// Catálogo
					case 'catalog': var wWindow = Titanium.UI.createWindow({ title:e.rowData.name, backgroundImage:getImage( 'background.png' ), backgroundColor:'#383b3d', url:'catalog.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
					// Novedades
					case 'newness': var wWindow = Titanium.UI.createWindow({ type:'newness', title:e.rowData.name, backgroundColor:'#383b3d', url:'products.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
					// Ofertas
					case 'offers': var wWindow = Titanium.UI.createWindow({ type:'offers', title:e.rowData.name, backgroundColor:'#383b3d', url:'products.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
					// Próximamente
					case 'comingsoon': var wWindow = Titanium.UI.createWindow({ type:'comingsoon', title:e.rowData.name, backgroundColor:'#383b3d', url:'products.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
					// Categoría destacada
					case 'category': var wWindow = Titanium.UI.createWindow({ type:'products', id:e.rowData.value, title:e.rowData.text, backgroundColor:'#383b3d', url:'products.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
					// Información
					case 'information': var wWindow = Titanium.UI.createWindow({ title:e.rowData.name, backgroundImage:getImage( 'background.png' ), backgroundColor:'#383b3d', url:'information.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true }); break;
					// Nada
					case 'none': return false;
				}

				// Si estamos en iOS mostramos el topBar
				if( Titanium.Platform.osname != 'android' )
					wWindow.navBarHidden = false;

				// Abrimos la ventana
				openWindowInTab( wWindow );
			});

			// Notificaciones push //

			// iOS

			// Si la plataforma es iOS
			if( Titanium.Platform.osname == 'iphone' || Titanium.Platform.osname == 'ipad' )
			{
				// Registramos la notificación push
				Titanium.Network.registerForPushNotifications({	types:[Titanium.Network.NOTIFICATION_TYPE_BADGE, Titanium.Network.NOTIFICATION_TYPE_ALERT, Titanium.Network.NOTIFICATION_TYPE_SOUND],
					success:function(e)
					{
						// Registramos el dispositivo
						query({ query:'insertDeviceToken', data:{ devicetoken:e.deviceToken } });

						// Activadas las notificaciones push
						Titanium.Network.remoteNotificationTypes;
						Titanium.Network.remoteNotificationsEnabled;
					},
					error:function(e)
					{
						// Mostramos mensaje de error
						//Titanium.UI.createAlertDialog({ title:'Error', message:'Error al registrar el dispositivo para notificaciones push: ' + e.error, buttonNames:['Aceptar'] }).show();
					},
					callback:function(e)
					{
						// Si hemos recibido una notificación push //

						// Según el tipo de notificacion
						switch( e.data.type )
						{
							// Si queremos mostrar el detalle de un producto
							case 'productdetail':
								// Abrimos la ventana de detalle de producto
								var wWindow = Titanium.UI.createWindow({ id:e.data.id, title:e.data.name, backgroundColor:'#ffffff', url:'productdetail.js', navBarHidden:false, windowParent:Titanium.UI.currentWindow, navBarHidden:true });

								// Abrimos la ventana
								openWindowInTab( wWindow );

								break;
							// Si queremos mostrar una búsqueda
							case 'search':
								// Abrimos la ventana de productos
								var wWindow = Titanium.UI.createWindow({ type:'search', value:e.data.id, title:e.data.name, backgroundColor:'#ffffff', url:'products.js', navBarHidden:false, windowParent:Titanium.UI.currentWindow, navBarHidden:true });

								// Abrimos la ventana
								openWindowInTab( wWindow );

								break;
							// Si queremos mostrar una url
							case 'url':
								var wWindow = Titanium.UI.createWindow({ title:e.data.name, link:e.data.id, backgroundColor:'#ffffff', url:'web.js', windowParent:Titanium.UI.currentWindow, navBarHidden:true });

								// Abrimos la ventana
								openWindowInTab( wWindow );

								break;
						}

						// Quitamos el badge de la app
						Titanium.UI.iPhone.appBadge = null;
					}
				});
			}
		}
	}
});