Titanium.include( 'database.js' );
Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({}).show();

// Hacemos una consulta para obtener las ventanas de información principales
query({ query:'getMainInformations', data:{ language:Titanium.App.idlanguage }, callback:function(aResult)
	{
		// Si obtenemos un resultado correcto
		if( aResult !== false )
		{
			// Cálculo de tamaños //

			var nWidth = Titanium.Platform.displayCaps.platformWidth;
			var nHeight = Titanium.Platform.displayCaps.platformHeight;

			// Si la orientación es LANDSCAPE
			if( Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_RIGHT || Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_LEFT )
			{
				var nWidth = Ti.Platform.displayCaps.platformHeight;
				var nHeight = Ti.Platform.displayCaps.platformWidth;
			}

			var nLogoSize = wPer( 205 );
			var nRowSize = (nHeight - (Titanium.App.topBarSize + Titanium.App.tabGroupSize + nLogoSize) - 10) / ((aResult.length + 2) > 6 ? 6 : (aResult.length + 2));

			// Mostramos el logo
			var aLogo = Titanium.UI.createImageView({ image:getImage( 'title.png' ), top:Titanium.App.top, width:wPer( 320 ), height:nLogoSize });
			Titanium.UI.currentWindow.add( aLogo );

			// Información //

			// Añadimos al resultado la opción de FAQ de la App
			aResult[aResult.length] = { idinformation:-1, information:getLocatedString( 'information_faq' ) };
			// Añadimos al resultado la opción de Acerca de
			aResult[aResult.length] = { idinformation:-2, information:getLocatedString( 'information_about_us' ) };

			// Creamos la tabla para mostrar las categorías principales
			var tTable = Titanium.UI.createTableView({ left:0, right:0, top:aLogo.top + aLogo.height + wPer( 10 ), bottom:Titanium.App.bottom + 10, borderRadius:0, separatorStyle:0, backgroundColor:'transparent' });

			// Array de datos
			var aData = [];

			// Recorremos el resultado y lo añadimos a la tabla
			for( var nCont = 0; nCont < aResult.length; nCont++ )
			{
				// Creamos la fila
				if( nCont == 0 )
				{
					var aRowSpace = Titanium.UI.createTableViewRow({ type:'none', className:'sections_none', backgroundColor:'#ddc559', hasChild:false });
					css( aRowSpace, 'home_table_row_space' );
					aData.push( aRowSpace );
				}

				// Creamos la fila
				var aRow = Titanium.UI.createTableViewRow({	id:aResult[nCont].idinformation, text:aResult[nCont].information, height:nRowSize, className:'information', backgroundImage:getImage( 'row_off.png' ),	selectedBackgroundImage:getImage( 'row_on.png' ), hasChild:false });
				css( aRow, 'home_table_row' );

				// Creamos la imagen izquierda
				var iImage =  Titanium.UI.createImageView({ image:getImage( 'information_off.png' ), width:nWidth * 0.0875, height:nWidth * 0.0875, left:wPer( 85 ), backgroundColor:'transparent', hires:true });
				aRow.add( iImage );
				aRow.row_left_image = iImage;
				// Creamos el label del titulo
				var lTitle = Titanium.UI.createLabel({ text:aResult[nCont].information, minimumFontSize:2, font:{ fontSize:wPer( 25 ), fontWeight:'bold', fontFamily:'Helvetica Neue' }, color:'#ddc559', textAlign:'left', left:iImage.left + iImage.width + ( iImage.left / 2 ), right:iImage.left, height:aRow.height });
				aRow.add( lTitle );
				aRow.row_title = lTitle;
				// Creamos la flecha derecha
				var iArrow = Titanium.UI.createImageView({ image:getImage( 'row_arrow_off.png' ), right:wPer( 30 ), width:wPer( 16 ), height:wPer( 25 ) });
				aRow.add( iArrow );
				aRow.row_arrow = iArrow;

				// Creamos la fila con espacio
				var aRowSpace = Titanium.UI.createTableViewRow({ type:'none', className:'sections_none', backgroundColor:'#ddc559', hasChild:false });
				css( aRowSpace, 'home_table_row_space' );

				// Añadimos la fila a los datos
				aData.push( aRow );
				aData.push( aRowSpace );
			}

			// Añadimos los datos a la tabla
			tTable.setData( aData );

			// Añadimos la tabla
			Titanium.UI.currentWindow.add( tTable );

			// Evento cuando pulsamos en un elemento de la lista
			tTable.addEventListener('touchstart', function(e)
			{
				// Cambiamos los colores
				if( ! Titanium.App.isAndroid )
				{
					e.rowData.row_left_image.image = e.rowData.row_left_image.image.replace( '_off', '_on' );
					e.rowData.row_title.color = '#000000';
					e.rowData.row_arrow.image = getImage( 'row_arrow_on.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchend', function(e)
			{
				// Cambiamos los colores
				if( ! Titanium.App.isAndroid )
				{
					e.rowData.row_left_image.image = e.rowData.row_left_image.image.replace( '_on', '_off' );
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando soltamos un elemento de la lista
			tTable.addEventListener('touchcancel', function(e)
			{
				// Cambiamos los colores
				if( ! Titanium.App.isAndroid )
				{
					e.rowData.row_left_image.image = e.rowData.row_left_image.image.replace( '_on', '_off' );
					e.rowData.row_title.color = '#ddc559';
					e.rowData.row_arrow.image = getImage( 'row_arrow_off.png' );
				}
			});

			// Evento cuando hacemos click en un elemento de la lista
			tTable.addEventListener('click', function(e)
			{
				// Abrimos la ventana de información
				var wInformation = Titanium.UI.createWindow({ id:e.rowData.id, title:e.rowData.text, backgroundImage:getImage( 'background.png' ), url:'informationdetail.js', windowParent:Titanium.UI.currentWindow });

				// Abrimos la ventana
				openWindowInTab( wInformation );
			});
		}
	}
});