Titanium.include( 'database.js' );
Titanium.include( '/functions/app.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/forms.class.js' );
Titanium.include( '/classes/saves.class.js' );
Titanium.include( '/classes/topbar.class.js' );

// Cálculo de tamaños //

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Formulario //

// Creamos el contenedor scroll
var sContent = Titanium.UI.createScrollView({ left:0, right:0, top:(nHeight / 5) * 3, bottom:0, backgroundColor:'transparent', contentWidth:'auto', contentHeight:'auto', layout:'vertical', showVerticalScrollIndicator:true });
Titanium.UI.currentWindow.add( sContent );

// Clase para el formulario
var aForm = new form( sContent );

// Creamos todos los campos
var aLanguage = aForm.addCombo({ name:'Idioma', hintText:'Español', top:20, values:Titanium.App.languages, defaultValue:Titanium.App.idlanguage });

// Botón para aceptar
var bContinue = Titanium.UI.createButton({ title:'Continuar', top:30, width:nWidth * 0.7156, height:nHeight * 0.075, backgroundImage:getImage( 'button_account_enter.png' ) });
sContent.add( bContinue );

// Evento cuando hacemos click en continuar
bContinue.addEventListener( 'click', function(e)
{
	// Establecemos el idioma seleccionado
	Titanium.App.language = aLanguage.text.toLowerCase().substr( 0, 2 );
	Titanium.App.idlanguage = aLanguage.id;

	// Añadimos el idioma en la configuración
	var aFile = Titanium.Filesystem.getFile( Titanium.Filesystem.applicationDataDirectory, 'lang.txt' );
	aFile.open( Titanium.Filesystem.MODE_WRITE );  
	aFile.write( Titanium.App.language + ':' + Titanium.App.idlanguage );

	// Cerramos la ventana
	Titanium.UI.currentWindow.close();
});