Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

/* Cálculo de tamaños */

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;
var nButtonSize = nWidth * 0.096875;
var nButtonStandardSize = nWidth * 0.2375;
var nButtonSatelliteHybridSize = nWidth * 0.23125;

/* Barra de tareas */

// Creamos la vista para contener los botones de ordenación
vTasks = Titanium.UI.createView({ bottom:Titanium.App.bottom, width:nWidth, height:nHeight * 0.092, backgroundGradient:{type:'linear', colors:['#ef805c','#d36c49'], startPoint:{x:0,y:0}, endPoint:{x:0,y:nHeight * 0.092}, backFillStart:false}, backgroundColor:'#ef805c' });
css( vTasks, 'products_order_bar' );
// Creamos las lineas decorativas
vTasks.add( Titanium.UI.createView({ top:0, width:nWidth, height:1, backgroundColor:'#afeaff' }) );
vTasks.add( Titanium.UI.createView({ bottom:0, width:nWidth, height:1, backgroundColor:'#6fd7fc' }) );

// Botones de mapa
var bStandard = Titanium.UI.createLabel({ text:getLocatedString( 'text_map_standard' ), textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontSize:nWidth * 0.0406, fontWeight:'regular' }, color:'#ffffff', backgroundImage:getImage( 'map_filter_standard_off.png' ), width:nButtonStandardSize, height:nButtonSize, left:(nWidth - (nButtonStandardSize + (nButtonSatelliteHybridSize * 2) + (nButtonSize * 2))) / 2 });
vTasks.add( bStandard );
var bSatellite = Titanium.UI.createLabel({ text:getLocatedString( 'text_map_satellite' ), textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontSize:nWidth * 0.0406, fontWeight:'regular' }, color:'#ffffff', backgroundImage:getImage( 'map_filter_satellite_hybrid_off.png' ), width:nButtonSatelliteHybridSize, height:nButtonSize, left:bStandard.left + bStandard.width });
vTasks.add( bSatellite );
var bHybrid = Titanium.UI.createLabel({ text:getLocatedString( 'text_map_hybrid' ), textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontSize:nWidth * 0.0406, fontWeight:'bold' }, color:'#ffffff', backgroundImage:getImage( 'map_filter_satellite_hybrid_on.png' ), width:nButtonSatelliteHybridSize, height:nButtonSize, left:bSatellite.left + bSatellite.width });
vTasks.add( bHybrid );
var bZoomIn = Titanium.UI.createLabel({ text:'', textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontSize:nWidth * 0.0406, fontWeight:'bold' }, color:'#ffffff', backgroundImage:getImage( 'map_filter_+_off.png' ), width:nButtonSize, height:nButtonSize, left:bHybrid.left + bHybrid.width });
vTasks.add( bZoomIn );
var bZoomOut = Titanium.UI.createLabel({ text:'', textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontSize:nWidth * 0.0406, fontWeight:'bold' }, color:'#ffffff', backgroundImage:getImage( 'map_filter_-_off.png' ), width:nButtonSize, height:nButtonSize, left:bZoomIn.left + bZoomIn.width });
vTasks.add( bZoomOut );
Titanium.UI.currentWindow.add( vTasks );

// Evento cuando hacemos click en el botón de mapa estándar
bStandard.addEventListener('click', function(e)
{
	// Deseleccionamos todos los botones
	deselectButtons();
	// Cambiamos la imagen del botón y el color
	bStandard.backgroundImage = getImage( 'map_filter_standard_on.png' );
	bStandard.color = '#ffffff';
	bStandard.font = { fontSize:bStandard.font.fontSize, fontWeight:'bold' };
	// Indicamos que el mapa sea estándar
	mapView.setMapType( Titanium.Map.STANDARD_TYPE );
});

// Evento cuando hacemos click en el botón de mapa satélite
bSatellite.addEventListener('click', function(e)
{
	// Deseleccionamos todos los botones
	deselectButtons();
	// Cambiamos la imagen del botón y el color
	bSatellite.backgroundImage = getImage( 'map_filter_satellite_hybrid_on.png' );
	bSatellite.color = '#ffffff';
	bSatellite.font = { fontSize:bSatellite.font.fontSize, fontWeight:'bold' };
	// Indicamos que el mapa sea satélite
	mapView.setMapType( Titanium.Map.SATELLITE_TYPE );
});

// Evento cuando hacemos click en el botón de mapa híbrido
bHybrid.addEventListener('click', function(e)
{
	// Deseleccionamos todos los botones
	deselectButtons();
	// Cambiamos la imagen del botón y el color
	bHybrid.backgroundImage = getImage( 'map_filter_satellite_hybrid_on.png' );
	bHybrid.color = '#ffffff';
	bHybrid.font = { fontSize:bHybrid.font.fontSize, fontWeight:'bold' };
	// Indicamos que el mapa sea híbrido
	mapView.setMapType( Titanium.Map.HYBRID_TYPE );
});

// Eventos que se lanzan cuando tocamos el botón de zoom +
bZoomIn.addEventListener('touchstart', function(e){ bZoomIn.backgroundImage = getImage( 'map_filter_+_on.png' ); });
bZoomIn.addEventListener('touchend', function(e){ bZoomIn.backgroundImage = getImage( 'map_filter_+_off.png' ); });

// Evento cuando hacemos click en el botón de zoom +
bZoomIn.addEventListener('click', function(e)
{
	// Hacemos zoom
	mapView.zoom( 1 );
});

// Eventos que se lanzan cuando tocamos el botón de zoom -
bZoomOut.addEventListener('touchstart', function(e){ bZoomOut.backgroundImage = getImage( 'map_filter_-_on.png' ); });
bZoomOut.addEventListener('touchend', function(e){ bZoomOut.backgroundImage = getImage( 'map_filter_-_off.png' ); });

// Evento cuando hacemos click en el botón de zoom -
bZoomOut.addEventListener('click', function(e)
{
	// Hacemos zoom
	mapView.zoom( -1 );
});

function deselectButtons()
{
	// Quitamos las imágenes de selección
	bStandard.backgroundImage = getImage( 'map_filter_standard_off.png' );
	bSatellite.backgroundImage = getImage( 'map_filter_satellite_hybrid_off.png' );
	bHybrid.backgroundImage = getImage( 'map_filter_satellite_hybrid_off.png' );
	bStandard.color = '#ffffff';
	bSatellite.color = '#ffffff';
	bHybrid.color = '#ffffff';
	bStandard.font = { fontSize:bStandard.font.fontSize, fontWeight:'regular' };
	bSatellite.font = { fontSize:bSatellite.font.fontSize, fontWeight:'regular' };
	bHybrid.font = { fontSize:bHybrid.font.fontSize, fontWeight:'regular' };
}

/* Mapa */

// Obtenemos los parámetros de la anotación en el mapa
var storeParams = { latitude:Titanium.UI.currentWindow.latitude, longitude:Titanium.UI.currentWindow.longitude, title:Titanium.UI.currentWindow.name, subtitle:Titanium.UI.currentWindow.address, animate:true };
// Obtenemos el icono del mapa
if( Titanium.Platform.name == 'android' ) storeParams.pinImage = getImage( 'map_pin.png' ); else storeParams.pincolor = Titanium.Map.ANNOTATION_GREEN;
// Creamos la anotación para el mapa
var store = Titanium.Map.createAnnotation( storeParams );

// Creamos el mapa
var mapView = Titanium.Map.createView({ mapType:Titanium.Map.HYBRID_TYPE, region:{latitude:Titanium.UI.currentWindow.latitude, longitude:Titanium.UI.currentWindow.longitude, latitudeDelta:0.04, longitudeDelta:0.04}, animate:true, regionFit:true, userLocation:true, annotations:[store], top:Titanium.App.top, bottom:Titanium.App.bottom + vTasks.height });
// Hacemos zoom al máximo
for( var nCont = 0; nCont < 5; nCont++ )
	mapView.zoom( 1 );
// Añadimos la anotación al mapa
if( ! Titanium.Platform.name == 'android' )
	mapView.addAnnotation( store );
mapView.selectAnnotation( store );
// Añadimos el mapa
Titanium.UI.currentWindow.add( mapView );