Titanium.include( 'database.js' );
Titanium.include( '/functions/app.js' );
Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/currencies.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/functions/share.js' );
Titanium.include( '/classes/topbar.class.js' );
Titanium.include( '/classes/saves.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({ backButton:true }).show();

// Imagen de fondo
Titanium.UI.currentWindow.backgroundImage = getImage( 'background_2.png' );

// Hacemos una consulta para obtener el producto
query({ query:'getProductDetail', data:{ id:Titanium.UI.currentWindow.id, userid:(Titanium.App.User == undefined ? false : Titanium.App.User.userid), language:Titanium.App.idlanguage }, callback:function(aResult)
	{
		// Si obtenemos un resultado correcto
		if( aResult !== false )
		{
			/* Cálculo de tamaños */

			var nWidth = Titanium.Platform.displayCaps.platformWidth;
			var nHeight = Titanium.Platform.displayCaps.platformHeight;

			// Calculamos el ancho y alto según la densidad
			if( Titanium.Platform.osname == 'android' )
			{
				// Ancho y alto según densidad
				nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
				nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
			}

			var nVisibleHeight = nHeight - Titanium.App.topBarSize - Titanium.App.tabGroupSize;
			var nBreadcumsSize = nVisibleHeight * 0.09;
			var nImageSize = ( nWidth / 2.2 ) - 20;
			var nBuySize = nHeight * 0.165;

			/* Calculo de precio */

			// Comprobamos si el producto está en oferta
			aResult.offer = (aResult.price_offer != null);

			// Si tenemos un precio de grupo lo cambiamos al precio
			if( aResult.price_group != null )
				aResult.price = aResult.price_group;

			// Obtenemos el precio original y el precio en oferta
			fPrice = aResult.price;
			fPriceOffer = aResult.price_offer;

			// Guardamos los precios
			aResult.price = getPriceFormatted( (aResult.offer ? fPriceOffer : fPrice), aResult.tax );
			aResult.price_offer = getPriceFormatted( (aResult.offer ? fPrice : false), aResult.tax );

			/* Breadcums */

			// Creamos la vista para contener los breadcums
			var vBreadcums = Titanium.UI.createView({ top:Titanium.App.top, width:nWidth, height:nBreadcumsSize, backgroundColor:'#dedcdd' });
			Titanium.UI.currentWindow.add( vBreadcums );
			// Creamos el label del breadcum
			var lBreadcum = Titanium.UI.createLabel({ text:getLocatedString( 'sections_catalog' ) + ' > ' + aResult.breadcums + aResult.category, font:{ fontSize:nBreadcumsSize / 3 }, color:'#494949', left:5 });
			vBreadcums.add( lBreadcum );

			/* Imágenes del producto */

			// Obtenemos la URL de la imagen
			var sImage = (aResult.image != '' && aResult.image != null ? Titanium.App.images + 'img/p/' + aResult.image.split( '' ).join( '/' ) + '/' + aResult.image + '-large.jpg' : '');

			// Creamos la imágen principal
			var iImage =  Titanium.UI.createImageView({ image:encodeURI( sImage ), width:nImageSize, height:nImageSize, top:Titanium.App.top + nBreadcumsSize + 5, left:5, backgroundColor:'transparent', hires:true });
			Titanium.UI.currentWindow.add( iImage );
			// Creamos la imagen de la lupa para mostrar que se puede ampliar
			var iGlass = Titanium.UI.createImageView({ image:getImage( 'magnify.png' ), width:nWidth * 0.046875, height:nWidth * 0.046875, top:iImage.top + iImage.height - 20, left:(iImage.left + iImage.width) - (nWidth * 0.046875), backgroundColor:'transparent' });
			Titanium.UI.currentWindow.add( iGlass );
			if( aResult.offer )
			{
				var iOffer = Titanium.UI.createImageView({ image:getImage( 'offer_product_detail_' + Titanium.App.language + '.png' ), width:wPer( 151 ), height:wPer( 126 ), top:Titanium.App.top + nBreadcumsSize + 1, left: 1, backgroundColor:'transparent' });
				Titanium.UI.currentWindow.add( iOffer );

				// Evento cuando hacemos click en la imagen de oferta
				iOffer.addEventListener('click', function(e)
				{
					// Mostramos la galería de imágenes
					showGallery();
				});
			}

			// Evento cuando hacemos click en la imagen de la lupa
			iGlass.addEventListener('click', function(e)
			{
				// Mostramos la galería de imágenes
				showGallery();
			});

			// Evento cuando hacemos click en la imagen
			iImage.addEventListener('click', function(e)
			{
				// Mostramos la galería de imágenes
				showGallery();
			});

			var showGallery = function()
			{
				// Obtenemos la URL de la imagen
				var aImages = aResult.images.split( ',' );

				// Recorremos las imagenes y le damos el enlace real
				for( var nCont = 0; nCont < aImages.length; nCont++ )
					aImages[nCont] = Titanium.App.images + 'img/p/' + aImages[nCont].split( '' ).join( '/' ) + '/' + aImages[nCont] + '-large.jpg'

				// Abrimos la ventana galería de imágenes
				var wGallery = Titanium.UI.createWindow({ title:getLocatedString( 'window_gallery' ), images:aImages, backButtonTitle:'Volver', tabBarHidden:true, backgroundImage:getImage( 'background.png' ), url:'gallery.js', windowParent:Titanium.UI.currentWindow });

				// Abrimos la ventana
				openWindow( wGallery );
			}

			/* Información */

			// Label del título del producto
			var lTitle = Titanium.UI.createLabel({ text:(aResult.product.length > 80 ? aResult.product.substr( 0, 77 ) + '...' : aResult.product ), font:{ fontSize:nWidth * 0.046875, fontWeight:'bold' }, color:(! aResult.offer ? '#312f2f' : '#19b9cc'), top:iImage.top - 5, left:iImage.left + iImage.width + 10, right:5, height:nImageSize / 2 });
			Titanium.UI.currentWindow.add( lTitle );
			// Mostramos el precio
			var aPrice = showPrice( { price:aResult.price, fontSize:nWidth * 0.09375, left:lTitle.left, top:iImage.top + iImage.height - (nWidth / 9), width:nWidth - lTitle.left, height:(nWidth * 0.09375) * 2, offer:aResult.price_offer, color:'#000000' } );
			Titanium.UI.currentWindow.add( aPrice );
			// Imagen del stock
			var iStock =  Titanium.UI.createImageView({ image:getStockImage( parseInt( aResult.quantity ) ), width:wPer( 19 ), height:wPer( 19 ), top:aPrice.top, left:lTitle.left });
			Titanium.UI.currentWindow.add( iStock );
			iStock.top = iStock.top - iStock.height;
			// Label para los detalles
			var lDetail = Titanium.UI.createLabel({ text:(aResult.reference != '' && aResult.reference != null ? 'Referencia: ' + aResult.reference + "\n" : '') + (aResult.model != '' && aResult.model != null ? 'Marca: ' + aResult.model + "\n" : ''), font:{ fontSize:nImageSize / 15 }, color:'#929292', top:lTitle.top + lTitle.height, height:iStock.top - (lTitle.top + lTitle.height), left:lTitle.left, right:5 });
			Titanium.UI.currentWindow.add( lDetail );

			// Botón para añadir el producto a favoritos
			var bFavorites = Titanium.UI.createLabel({ text:'  ' + getLocatedString( 'pd_favorites' ), textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0375, fontWeight:'bold' }, color:'#dba000', backgroundImage:getImage( 'button_favorites.png' ), id:aResult.idproduct, top:iImage.top + iImage.height + 15, left:5, width:nWidth * 0.291, height:nHeight * 0.0458 });
			Titanium.UI.currentWindow.add( bFavorites );
			bFavorites.left = (nWidth - (bFavorites.width * 3)) / 4;

			// Evento que se lanza cuando hacemos click en el botón de añadir a favoritos
			bFavorites.addEventListener('click', function(e)
			{
				// Salvamos los favoritos
				aSaves = new Saves( 'favorites' );
				aSaves.favoritesSave({ idproduct:Titanium.UI.currentWindow.id });
			});

			// Botón para compartir el producto
			var bShare = Titanium.UI.createLabel({ text:'  ' + getLocatedString( 'pd_share' ), textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0375, fontWeight:'bold' }, color:'#3a62b3', backgroundImage:getImage( 'button_share.png' ), top:bFavorites.top, left:bFavorites.left + bFavorites.width + bFavorites.left, width:nWidth * 0.291, height:nHeight * 0.0458 });
			Titanium.UI.currentWindow.add( bShare );

			// Evento que se lanza cuando hacemos click en el botón de compartir
			bShare.addEventListener('click', function(e)
			{
				// Creamos una ventana de diálogo con opciones para compartir
				var dDialog = Titanium.UI.createOptionDialog({ title:getLocatedString( 'window_share' ), options:['Facebook', 'Twitter', getLocatedString( 'text_cancel' )], destructive:2 });

				// Mostramos las opciones
				dDialog.show();

				// Evento que se lanza cuando se clica sobre alguna de las opciones del diálogo
				dDialog.addEventListener( 'click', function(e)
				{
					// Componemos el mensaje
		    		var sShare = aResult.product + ' ' + Titanium.App.server + aResult.idproduct + '-' + replaceAll( replaceAll( aResult.product.trim().toLowerCase(), ' ', '-' ), '--', '-' ) + '.html' + "\n";

					// Facebook
				    if( e.index == 0 )
				    {
				    	// Compartir en Facebook
				    	shareFacebook(
				    	{
				    		message: 'Quiero compartir un producto de la tienda ' + Titanium.App.store_name + ':\n\n' + sShare,
				    		dialog: false
				    	});
				    }
				    // Twitter
				    else if( e.index == 1 )
				    {
				    	// Compartir en Twitter
				    	shareTwitter(
				    	{
				    		message: 'Mira este producto de ' + Titanium.App.store_name + ': ' + sShare,
				    		dialog: false
				    	});
				    }
				});
			});

			// Botón para ver el producto en un video de Youtube
			if( aResult.video != null && aResult.video != '' )
			{
				var bVideo = Titanium.UI.createButton({ text:'  Video', textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0375, fontWeight:'bold' }, color:'#e51e1e', backgroundImage:getImage( 'button_video.png' ), video:aResult.video, top:bFavorites.top, left:bShare.left + bFavorites.width + bFavorites.left, width:nWidth * 0.291, height:nHeight * 0.0458 });
				Titanium.UI.currentWindow.add( bVideo );

				// Evento que se lanza cuando hacemos click en el botón de ver video
				bVideo.addEventListener('click', function(e)
				{
					// Abrimos el video
					//Ti.Platform.openURL( 'http://www.youtube.com/embed/' + e.source.video + '/' );

					// Creamos la ventana de descripcióm ampliada de producto
					var wVideo = Titanium.UI.createWindow({ link:'http://www.youtube.com/embed/' + e.source.video + '/', backButtonTitle:'Volver', tabBarHidden:true, backgroundColor:'#ffffff', url:'web.js', windowParent:Titanium.UI.currentWindow });

					// Abrimos la ventana
					openWindow( wVideo );
				});
			}

			/* Barra de comprar */

			// Contenedor para la barra de comprar			
			vBuy = Titanium.UI.createView({ left:0, right:0, bottom:Titanium.App.bottom, width:nWidth, height:nBuySize, backgroundColor:'#2e2e2e' });
			Titanium.UI.currentWindow.add( vBuy );

			// Botón de comprar
			bBuy = Titanium.UI.createLabel({ text:getLocatedString( 'pd_buy' ), textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontFamily:'Helvetica Neue', fontSize:nWidth * 0.0625, fontWeight:'bold' }, color:'#ffffff', backgroundImage:getImage( 'button_buy.png' ), right:10, width:nWidth * 0.684375, height:nHeight * 0.104166, enabled:true });
			vBuy.add( bBuy );

			// Si el producto no está disponible
			if( aResult.date_available != 'false' )
			{
				bBuy.text = getLocatedString( 'pd_buy_soon' ) + ' ' + aResult.date_available;
				bBuy.font = { fontFamily:'Helvetica Neue', fontSize:nWidth * 0.03125, fontWeight:'bold' };
				bBuy.enabled = false;
			}

			// Creamos la caja de texto para la cantidad
			var lQuantity = Titanium.UI.createLabel({ text:'1', textAlign:Titanium.UI.TEXT_ALIGNMENT_CENTER, font:{ fontSize:nWidth / 12, fontWeight:'regular' }, color:'#606060', left:10, width:bBuy.height, height:bBuy.height, borderRadius:5, borderWidth:1, borderColor:'#9e9e9e', backgroundColor:'#ffffff' });
			vBuy.add( lQuantity );

			// Evento cuando hacemos click en comprar
			bBuy.addEventListener('click', function(e)
			{
				// Si está activado el comprar
				if( bBuy.enabled )
				{
					// Cambiamos los colores a los bordes
					lQuantity.borderColor = '#9e9e9e';

					// Ocultamos el picker
					vPicker.animate( Titanium.UI.createAnimation({ top:-vPicker.height }) );

					// Salvamos el carrito
					aSaves = new Saves( 'cart' );
					aSaves.cartSave({ idproduct:Titanium.UI.currentWindow.id, quantity:parseInt( lQuantity.text ) });
				}
			});

			// Evento cuando hacemos click en el label de cantidad
			lQuantity.addEventListener('click', function(e)
			{
				// Cambiamos los colores a los bordes
				e.source.borderColor = '#f7b06b';

				// Seleccionamos el valor en el picker
				pPicker.setSelectedRow( 0, parseInt( e.source.text ) - 1 );

				// Mostramos el picker
				vPicker.animate( Titanium.UI.createAnimation({ top:0 }) );
			});

			// Limpiamos acentos
			if( aResult.description_short != '' && aResult.description_short != null )
			{
				aResult.description_short = aResult.description_short.replace( '&aacute;', 'á' ).replace( '&eacute;', 'é' ).replace( '&iacute;', 'í' ).replace( '&oacute;', 'ó' ).replace( '&uacute;', 'ú' );
				aResult.description_short = aResult.description_short.replace( '&iexcl;', '¡' ).replace( '&nbsp;', ' ' );
			}

			// Label para la descripción del producto
			var lDescription = Titanium.UI.createLabel({ text:aResult.description_short, font:{ fontSize:nWidth / 25, fontWeight:'regular' }, color:'#a3a2a2', left:bFavorites.left + ((bFavorites.width / 3) * 2), top:bFavorites.top + bFavorites.height + 5, width:(bShare.left + bFavorites.width + bFavorites.left + bFavorites.width) - (bFavorites.left + ((bFavorites.width / 3) * 2)), height:(nHeight - vBuy.height) - (bFavorites.top + bFavorites.height + (Titanium.Platform.osname == 'android' ? Titanium.App.topBarSize : Titanium.App.topBarSize)) - 40 });
			Titanium.UI.currentWindow.add( lDescription );
			// Imagen decorativa para la descripción
			var iDescription = Titanium.UI.createImageView({ image:getImage( 'information_product.png' ), width:nWidth * 0.091, height:nWidth * 0.091, backgroundColor:'transparent', hires:true });
			iDescription.left = (lDescription.left / 2) - (iDescription.width / 2);
			iDescription.top = lDescription.top + (lDescription.height / 2) - (iDescription.height / 2);
			Titanium.UI.currentWindow.add( iDescription );
			// Label para ver más información
			var lMore = Titanium.UI.createLabel({ text:'+', font:{ fontFamily:'Helvetica Neue', fontSize:nWidth / 25, fontWeight:'bold' }, color:'#494949', left:lDescription.left + lDescription.width, top:lDescription.top + lDescription.height - (nHeight * 0.03125), width:'auto', height:'auto' });
			Titanium.UI.currentWindow.add( lMore );
			// Creamos la vista invisible para clicar la descripción
			var lDescriptionView = Titanium.UI.createView({ left:0, right:0, top:lDescription.top, height:lDescription.height, backgroundColor:'transparent' });
			Titanium.UI.currentWindow.add( lDescriptionView );

			// Evento cuando hacemos click en la descripción
			lDescriptionView.addEventListener('click', function(e)
			{
				// Creamos la ventana de descripcióm ampliada de producto
				var wDescription = Titanium.UI.createWindow({ title:getLocatedString( 'window_description' ), desc:aResult.description, backButtonTitle:'Volver', tabBarHidden:true, backgroundImage:getImage( 'background.png' ), url:'description.js', windowParent:Titanium.UI.currentWindow });

				// Abrimos la ventana
				openWindow( wDescription );
			});

			/* Picker de cantidad */

			// Creamos la vista para el picker
			if( Titanium.Platform.osname == 'android' ) vPicker = Titanium.UI.createView({ height:163, top:-163, backgroundColor:'#000000' });
			else if( Titanium.Platform.osname == 'ipad' ) vPicker = Titanium.UI.createView({ height:480 * 0.5416, top:-(480 * 0.5416), backgroundColor:'transparent' });
			else vPicker = Titanium.UI.createView({ height:nHeight * 0.5416, top:-(nHeight * 0.5416), backgroundColor:'transparent' });
			Titanium.UI.currentWindow.add( vPicker );
			// Creamos la barra de tareas
			var vToolBar = Titanium.UI.createView({ bottom:0, height:nHeight * 0.0916, backgroundColor:'#000000', opacity:0.3 });
			vPicker.add( Titanium.UI.createView({ bottom:0, height:1, backgroundColor:'#343434' }) );
			vPicker.add( Titanium.UI.createView({ bottom:1, height:1, backgroundColor:'#b8b8b8' }) );
			vPicker.add( vToolBar );
			// Creamos el botón de OK
			var bPickerOK = showButton( 'OK', { right:5, bottom:5 }, function(e)
				{
					// Cambiamos los colores a los bordes
					lQuantity.borderColor = '#9e9e9e';

					// Ocultamos el picker
					vPicker.animate( Titanium.UI.createAnimation({ top:-vPicker.height }) );
				}
			);
			vPicker.add( bPickerOK );
			// Creamos el picker de cantidad
			pPicker = Titanium.UI.createPicker({ top:0, selectionIndicator:true, useSpinner:true });
			// Rellenamos los datos
			aPickerData = [];
			for( nCont = 1; nCont <= 100; nCont++ )
				aPickerData.push( Titanium.UI.createPickerRow({ title:nCont.toString() }) );
			pPicker.add( aPickerData );
			vPicker.add( pPicker );

			// Evento cuando cambiamos de valor con el picker
			pPicker.addEventListener('change', function(e)
			{
				// Actualizamos el campo
				lQuantity.text = e.selectedValue[0];
			});
		}
	}
});