Titanium.include( 'database.js' );
Titanium.include( '/functions/css.js' );
Titanium.include( '/functions/images.js' );
Titanium.include( '/classes/topbar.class.js' );

/* TopBar */

// Mostramos el TopBar
new topBar({ showSearchButton:false }).show();

/* Cálculo de tamaños */

var nWidth = Titanium.Platform.displayCaps.platformWidth;
var nHeight = Titanium.Platform.displayCaps.platformHeight;

// Si no tenemos el ID de una tienda buscamos todas
if( Titanium.UI.currentWindow.id == undefined )
{
	// Hacemos una consulta para obtener las tiendas
	query({ query:'getStores', data:{ language:Titanium.App.idlanguage }, callback:function(aResult)
		{
			// Si solo hemos obtenido una tienda la mostramos
			if( aResult.length == 1 )
				showStore( aResult );
			// Si hemos obtenido más de una tienda mostramos ventana de selección
			else
			{
				// Creamos el contenedor scroll
				var sContent = Titanium.UI.createScrollView({ left:0, right:0, top:Titanium.App.top, bottom:Titanium.App.bottom, backgroundColor:'transparent', showVerticalScrollIndicator:true });
				Titanium.UI.currentWindow.add( sContent );

				// Variable para ir calculando el top
				var nTop = 0;

				// Recorremos las tiendas y las mostramos
				for( nCont = 0; nCont < aResult.length; nCont++ )
				{
					// Creamos la imágen de la tienda
					var iImage =  Titanium.UI.createImageView({ image:(aResult[nCont].photo != null && aResult[nCont].photo != '' ? aResult[nCont].photo : getImage( 'store_default.png' )), width:nWidth, height:nHeight * 0.2479, top:nTop, left:0, backgroundColor:'transparent', hires:true });
					sContent.add( iImage );
					// Creamos la vista para la banda del nombre
					var vName =  Titanium.UI.createView({ width:nWidth, height:nHeight * 0.07291, top:iImage.top + iImage.height - (nHeight * 0.07291), left:0, backgroundColor:'#9d6bc0', opacity:0.8, hires:true });
					sContent.add( vName );
					// Creamos la imágen de una flecha decorativa
					var iArrow =  Titanium.UI.createImageView({ image:getImage( 'arrow.png' ), width:nWidth * 0.0406, height:nHeight * 0.0395, top:(vName.top + (vName.height / 2)) - ((nHeight * 0.0395) / 2), left:nWidth * 0.07812, backgroundColor:'transparent', hires:true });
					sContent.add( iArrow );
					// Creamos el label del nombre de la tienda
					var lName = Titanium.UI.createLabel({ text:aResult[nCont].name, font:{ fontSize:nWidth * 0.0625, fontWeight:'bold' }, color:'#9d6bc0', textAlign:'left', height:vName.height, top:vName.top, left:iArrow.left + iArrow.width + (nWidth * 0.03125), backgroundColor:'transparent' });
					sContent.add( lName );
					// Creamos la vista para la selección
					var vStore =  Titanium.UI.createView({ id:aResult[nCont].idstore, title:aResult[nCont].name, width:nWidth, height:iImage.height, top:nTop, left:0, backgroundColor:'transparent', viewName:vName, imageArrow:iArrow, labelName:lName });
					sContent.add( vStore );

					// Evento cuando presionamos sobre una tienda
					vStore.addEventListener( 'touchstart', function(e)
					{
						// Cambiamos de color la vista del nombre
						e.source.viewName.backgroundColor = '#d55023';
						// Añadimos sombra al label del nombre
						if( Titanium.Platform.osname != 'android' )
							e.source.labelName.setShadowOffset({ x:1, y:1 });
						e.source.labelName.shadowColor = '#ffffff';
					});

					// Evento cuando dejamos de presionar sobre una tienda
					vStore.addEventListener( 'touchend', function(e)
					{
						// Cambiamos de color la vista del nombre
						e.source.viewName.backgroundColor = '#000000';
						// Quitamos la sombra al label del nombre
						if( Titanium.Platform.osname != 'android' )
							e.source.labelName.setShadowOffset({ x:0, y:0 });
						e.source.labelName.shadowColor = 'transparent';
					});

					// Evento cuando clicamos sobre una tienda
					vStore.addEventListener( 'singletap', function(e)
					{
						// Creamos la ventana de tienda
						var wWindow = Titanium.UI.createWindow({ id:e.source.id, title:e.source.title, backgroundImage:getImage( 'background.png' ), url:'stores.js', windowParent:Titanium.UI.currentWindow });

						// Abrimos la ventana
						openWindowInTab( wWindow );
					});

					// Aumentamos el top
					nTop = iImage.top + iImage.height + (nHeight * 0.0083);
				}
			}
		}
	});
}
// Si obtenemos el ID de una tienda la mostramos
else
	// Hacemos una consulta para obtener la información de la tienda
	query({ query:'getStoreByID', data:{ id:Titanium.UI.currentWindow.id, language:Titanium.App.idlanguage }, callback:showStore });

// Mostramos la información de la tienda
function showStore(aResult)
{
	// Nos posicionamos en el registro
	aResult = aResult[0];

	// Cambiamos el título de la ventana
	Titanium.UI.currentWindow.title = getLocatedString( 'text_stores' );

	// Creamos la imágen de la tienda
	var iImage =  Titanium.UI.createImageView({ image:(aResult.photo != null ? aResult.photo : getImage( 'store_default.png' )), width:wPer( 640 ), height:Titanium.App.stores_image_height, top:Titanium.App.top, left:0, backgroundColor:'transparent', hires:true });
	Titanium.UI.currentWindow.add( iImage );

	// Creamos el contenedor para el contacto
	var vContact = Titanium.UI.createView({ layout:'vertical', left:0, right:0, top:iImage.top + iImage.height + (nWidth * 0.015625), bottom:Titanium.App.bottom + (nWidth * 0.015625), backgroundColor:'transparent' });
	Titanium.UI.currentWindow.add( vContact );

	// Creamos el label de la dirección
	var lAddress = Titanium.UI.createLabel({ text:(aResult.address != '' ? aResult.address + ', ' : '') + (aResult.city != '' ? aResult.city + ' ' : '') + (aResult.postcode != '' ? aResult.postcode + ' ' : '') + aResult.state + ', ' + aResult.country, font:{ fontSize:nWidth * 0.04687, fontWeight:'bold' }, color:Titanium.App.general_font_color, textAlign:'center', left:(nWidth * 0.015625), right:(nWidth * 0.015625), height:'auto', top:0, backgroundColor:'transparent', wordWrap:true });
	vContact.add( lAddress );
	// Creamos el label del email
	var lEmail = Titanium.UI.createLabel({ text:aResult.email, font:{ fontSize:nWidth * 0.04687, fontWeight:'regular' }, color:Titanium.App.general_font_color, textAlign:'center', left:5, right:5, top:0, height:'auto', backgroundColor:'transparent' });
	vContact.add( lEmail );

	// Creamos el botón de llamar
	var bTelephone = Titanium.UI.createButton({ title:aResult.telephone, color:'#ffffff', top:5, width:nWidth * 0.7156, height:nHeight * 0.075, backgroundImage:getImage( 'button_account_register.png' ) });
	vContact.add( bTelephone );

	// Evento cuando hacemos click en el botón de llamar
	bTelephone.addEventListener( 'click', function(e)
	{
		// Eliminamos los espacios en blanco del teléfono
		var sTelephone = '';

		for( nChar = 0; nChar < aResult.telephone.length; nChar++ )
  			if( aResult.telephone[nChar] != ' ' )
    			sTelephone += aResult.telephone[nChar];

		// Llamamos al número de teléfono
		Titanium.Platform.openURL( 'tel:' + sTelephone );
	});

	// Creamos la imágen del mapa
	var iMap =  Titanium.UI.createImageView({ image:getImage( 'store_map.png' ), height:(aResult.latitude == '' ? 0 : nHeight * 0.1083), bottom:Titanium.App.bottom + (aResult.latitude == '' ? 0 : nHeight * 0.02083), backgroundColor:'transparent', hires:true });
	Titanium.UI.currentWindow.add( iMap );

	// Evento cuando hacemos click en el icono del mapa
	iMap.addEventListener( 'click', function(e)
	{
		// Si disponemos de latitud y longitud
		if( aResult.latitude != '' && aResult.longitude != '' )
		{
			// Creamos la ventana de mapas
			var wWindow = Titanium.UI.createWindow({ name:aResult.name, address:aResult.address, latitude:aResult.latitude, longitude:aResult.longitude, title:getLocatedString( 'window_localization' ), backgroundImage:getImage( 'background.png' ), url:'map.js', windowParent:Titanium.UI.currentWindow });

			// Abrimos la ventana
			openWindowInTab( wWindow );
		}
		// Si no informamos
		else
		{
			// Mensaje informando que no hay localización física
			Titanium.UI.createAlertDialog({ title:getLocatedString( 'text_message' ), message:'La tienda no dispone de una localización física.', buttonNames:['Aceptar'] }).show();
		}
	});

	// Creamos el contenedor para el contacto
	var vSchedule = Titanium.UI.createView({ layout:'vertical', left:0, right:0, top:5, backgroundColor:'transparent' });
	vContact.add( vSchedule );
	// Creamos el label del título del horario
	var lScheduleTitle = Titanium.UI.createLabel({ text:getLocatedString( 'text_stores_hours' ), font:{ fontSize:nWidth * 0.04687, fontWeight:'bold' }, color:Titanium.App.general_font_color, textAlign:'center', left:0, right:0, top:0, height:'auto', backgroundColor:'transparent' });
	vSchedule.add( lScheduleTitle );
	// Creamos el label del horario
	var lSchedule = Titanium.UI.createLabel({ text:aResult.schedule, font:{ fontSize:nWidth * 0.04687, fontWeight:'regular' }, color:Titanium.App.general_font_color, textAlign:'center', left:5, right:5, top:0, height:50, backgroundColor:'transparent', horizontalWrap:true });
	vSchedule.add( lSchedule );
}