// Cálculo de tamaños
var nWidth = Titanium.Platform.displayCaps.platformWidth; // 320
var nHeight = Titanium.Platform.displayCaps.platformHeight; // 480

// Si la orientación es LANDSCAPE
if( Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_RIGHT || Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_LEFT )
{
	var nWidth = Ti.Platform.displayCaps.platformHeight;
	var nHeight = Ti.Platform.displayCaps.platformWidth;
}

// Calculamos el ancho y alto según la densidad
if( Titanium.Platform.osname == 'android' )
{
	// Ancho y alto según densidad
	nWidth = ( nWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );
	nHeight = ( nHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );
}

// Declaramos la variable de estilo
var style =
[
	// Forms
	{
		class: 'field_label',
		color:'#FFFFFF'
	},
	{
		class: 'field_object',
		color: '#929191',
		backgroundColor: '#e5e5e5'
	},
	// Home
	{
		class: 'home_logo',
		left: ( nWidth / 2 ) - ( wPer( 320 ) / 2 ),
		top: wPer( 16 ),
		width: wPer( 320 ),
		height: wPer( 205 )
	},
	{
		class: 'home_gallery',
		//left: 0,
		//width: wPer( 640 ),
		height: (Titanium.Platform.osname == 'ipad' ? 270 : wPer( 354 ))
	},
	{
		class: 'home_table',
		left: 0,
		right: 0,
		bottom: Titanium.App.bottom + wPer( 35 ),
		borderRadius: 0
	},
	{
		class: 'home_table_row',
		height: Titanium.Platform.osname == 'ipad' ? 100 : nHeight * 0.088125
	},
	{
		class: 'home_table_row_space',
		height: 1
	},

	// Catálogo
	{
		class: 'catalog_title',
		top: Titanium.App.top,
		width: wPer( 320 ),
		height: wPer( 205 )
	},
	{
		class: 'catalog_table',
		left:nWidth * 0.05312,
		right:nWidth * 0.05312,
		top:Titanium.App.top + wPer( 10 ),
		bottom:Titanium.App.bottom,
		borderRadius:4
	},
	{
		class: 'catalog_table_row',
		height: nWidth * 0.20625
	},
	{
		class: 'catalog_table_row_space',
		height: 4
	},
	{
		class: 'catalog_table_row_image',
		left: 1,
		top:0,
		bottom: 0,
	},
	{
		class: 'catalog_table_row_title',
	},

	// Categorías
	{
		class: 'categories_table_row',
		selectedBackgroundColor: '#ddc559'
	},
	{
		class: 'categories_table_row_image',
		left: nWidth * 0.03125,
		top: nWidth * 0.03125,
		bottom: nWidth * 0.03125,
		width: ((nHeight - Titanium.App.topBarSize - Titanium.App.tabGroupSize) / 5) - ((nWidth * 0.03125) * 2)
	},
	{
		class: 'categories_table_row_title',
		left: ((nHeight - Titanium.App.topBarSize - Titanium.App.tabGroupSize) / 5),
	},
	{
		class: 'categories_table_row_quantity',
		left: ((nHeight - Titanium.App.topBarSize - Titanium.App.tabGroupSize) / 5),
	},

	// Productos listado
	{
		class: 'products_order_bar',
		//backgroundGradient: {type:'linear', colors: ['#fed631', '#fed631'], startPoint:{x:0,y:0}, endPoint:{x:0,y:nHeight * 0.092}, backFillStart:false},
		backgroundColor:'transparent'
	},
	{
		class: 'products_table_row',
		selectedBackgroundColor: '#bd9cd3'
	},
	{
		class: 'products_table_row_title',
		color: '#000000'
	},
	{
		class: 'products_table_row_title_offer',
		color: '#e8132c'
	},
	{
		class: 'products_offer',
		width:nWidth * 0.0875,
		top:0,
		right:0
	},
	{
		class: 'products_empty_information',
		left:10,
		right:10, 
		top:20,
		color: '#323333 ',
		shadowColor: 'transparent'
	},
	{
		class: 'products_empty_information_extra',
		left:10,
		right:10, 
		top:0,
		color: '#d5bb48',
		shadowColor: 'transparent'
	}
];



// Generales //
Titanium.App.general_font_color = '#0f7da3';

// Buscar y filtro //
Titanium.App.search_filter_barcolor_1 = '#afeaff';
Titanium.App.search_filter_barcolor_2 = '#afeaff';

// Precio
Titanium.App.price_color = '#6b696c';

// Cashout
Titanium.App.cashout_color = '#2e2e2e';
Titanium.App.cashout_border_color = '#2e2e2e';

// Tiendas //
Titanium.App.stores_image_height = wPer( 305 );

/**
 * Función que retorna en píxeles el tamaño proporcional respecto al ancho de la ventana y el ancho del diseño original
 * 
 * @param integer nPx
 * 
 * return integer
 * 
 */
function wPer(nPx)
{
	// Ancho del diseño original
	var nWidth = 640;
	var nPlatformWidth = Ti.Platform.displayCaps.platformWidth;
	var nPlatformHeight = Ti.Platform.displayCaps.platformHeight;

	// Si empieza las dimensiones cambiadas
	//if( nPlatformHeight > nPlatformWidth )
		//nPlatformWidth = nPlatformHeight;

	// Si la orientación es LANDSCAPE
	if( Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_RIGHT || Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_LEFT )
	{
		var nPlatformWidth = Ti.Platform.displayCaps.platformHeight;
		var nPlatformHeight = Ti.Platform.displayCaps.platformWidth;
	}

	// Calculamos el ancho según la densidad
	if( Titanium.Platform.osname == 'android' )
		nPlatformWidth = ( nPlatformWidth / ( Titanium.Platform.displayCaps.dpi / 160 ) );

	// Retornamos en píxeles el tamaño proporcional respecto al ancho de la ventana y el ancho del diseño original
	return ( nPlatformWidth * ( ( ( nPx * 100 ) / nWidth ) / 100 ) );
}

/**
 * Función que retorna en píxeles el tamaño proporcional respecto al alto de la ventana y el alto del diseño original
 * 
 * @param integer nPx
 * 
 * return integer
 * 
 */
function hPer(nPx)
{
	// Alto del diseño original
	var nHeight = 1136;
	var nPlatformWidth = Ti.Platform.displayCaps.platformWidth;
	var nPlatformHeight = Ti.Platform.displayCaps.platformHeight;

	// Si empieza las dimensiones cambiadas
	//if( nPlatformHeight > nPlatformWidth )
		//nPlatformHeight = nPlatformWidth;

	// Si la orientación es LANDSCAPE
	if( Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_RIGHT || Titanium.Gesture.orientation == Ti.UI.LANDSCAPE_LEFT )
	{
		var nPlatformWidth = Ti.Platform.displayCaps.platformHeight;
		var nPlatformHeight = Ti.Platform.displayCaps.platformWidth;
	}

	// Calculamos el alto según la densidad
	if( Titanium.Platform.osname == 'android' )
		nPlatformHeight = ( nPlatformHeight / ( Titanium.Platform.displayCaps.dpi / 160 ) );

	// Retornamos en píxeles el tamaño proporcional respecto al alto de la ventana y el alto del diseño original
	return ( nPlatformHeight * ( ( ( nPx * 100 ) / nHeight ) / 100 ) );
}